/***
*ctype.h - character conversion macros and ctype macros
*
*       Copyright (c) 1985-1997, Microsoft Corporation. All rights reserved.
*
*Purpose:
*       Defines macros ѭ character classification/conversion.
*       [ANSI/System V]
*
*       [Public]
*
****/

#     _MSC_VER > 1000
#ָ once
#

#δ _INC_CTYPE
# _INC_CTYPE

#     !Ѷ(_WIN32) && !defined(_MAC)
# ERROR: Only Mac or Win32 targets supported!
#


#Ѷ  __cplusplus
ⲿ "C" {
#



/* Define _CRTIMP */

#δ _CRTIMP
#Ѷ  _DLL
# _CRTIMP __declspec(dllimport)
#   /* ndef _DLL */
# _CRTIMP
#  /* _DLL */
#  /* _CRTIMP */


/* Define ϰ ѭ non-Microsoft compilers */

#     ( !Ѷ(_MSC_VER) && !defined(ϰ) )
# ϰ
#

/* Define _CRTAPI1 (ѭ compatibility with the NT SDK) */

#δ _CRTAPI1
#	_MSC_VER >= 800 && _M_IX86 >= 300
# _CRTAPI1 ϰ
#
# _CRTAPI1
#
#

#δ _WCHAR_T_DEFINED
Ͷ ޷  wchar_t;
# _WCHAR_T_DEFINED
#

#δ _MAC
#δ _WCTYPE_T_DEFINED
Ͷ wchar_t wint_t;
Ͷ wchar_t wctype_t;
# _WCTYPE_T_DEFINED
#

#δ WEOF
# WEOF (wint_t)(0xFFFF)
#
#  /* ndef _MAC */


#δ _CTYPE_DISABLE_MACROS
_CRTIMP ⲿ ޷  _ctype[];
_CRTIMP ⲿ ޷  *_pctype;
#δ _MAC
_CRTIMP ⲿ wctype_t *_pwctype;
#  /* ndef _MAC */
#  /* _CTYPE_DISABLE_MACROS */


/* set bit masks ѭ the possible character types */

# _UPPER          0x1     /* upper  letter */
# _LOWER          0x2     /* lower  letter */
# _DIGIT          0x4     /* digit[0-9] */
# _SPACE          0x8     /* tab, carriage , newline, */
                                /* vertical tab or form feed */
# _PUNCT          0x10    /* punctuation character */
# _CONTROL        0x20    /* control character */
# _BLANK          0x40    /* space ַ */
# _HEX            0x80    /* hexadecimal digit */

# _LEADBYTE       0x8000                  /* multibyte leadbyte */
# _ALPHA          (0x0100|_UPPER|_LOWER)  /* alphabetic character */


/* character classification function prototypes */

#δ _CTYPE_DEFINED

_CRTIMP  ϰ _isctype(, );
_CRTIMP  ϰ isalpha();
_CRTIMP  ϰ isupper();
_CRTIMP  ϰ islower();
_CRTIMP  ϰ isdigit();
_CRTIMP  ϰ isxdigit();
_CRTIMP  ϰ isspace();
_CRTIMP  ϰ ispunct();
_CRTIMP  ϰ isalnum();
_CRTIMP  ϰ isprint();
_CRTIMP  ϰ isgraph();
_CRTIMP  ϰ iscntrl();
_CRTIMP  ϰ toupper();
_CRTIMP  ϰ tolower();
_CRTIMP  ϰ _tolower();
_CRTIMP  ϰ _toupper();
_CRTIMP  ϰ __isascii();
_CRTIMP  ϰ __toascii();
_CRTIMP  ϰ __iscsymf();
_CRTIMP  ϰ __iscsym();
# _CTYPE_DEFINED
#


#δ _MAC
#δ _WCTYPE_DEFINED

/* wide function prototypes, also declared in wchar.h  */

/* character classification function prototypes */

_CRTIMP  ϰ iswalpha(wint_t);
_CRTIMP  ϰ iswupper(wint_t);
_CRTIMP  ϰ iswlower(wint_t);
_CRTIMP  ϰ iswdigit(wint_t);
_CRTIMP  ϰ iswxdigit(wint_t);
_CRTIMP  ϰ iswspace(wint_t);
_CRTIMP  ϰ iswpunct(wint_t);
_CRTIMP  ϰ iswalnum(wint_t);
_CRTIMP  ϰ iswprint(wint_t);
_CRTIMP  ϰ iswgraph(wint_t);
_CRTIMP  ϰ iswcntrl(wint_t);
_CRTIMP  ϰ iswascii(wint_t);
_CRTIMP  ϰ isleadbyte();

_CRTIMP wchar_t ϰ towupper(wchar_t);
_CRTIMP wchar_t ϰ towlower(wchar_t);

_CRTIMP  ϰ iswctype(wint_t, wctype_t);

/* --------- The following functions are OBSOLETE --------- */
_CRTIMP  ϰ is_wctype(wint_t, wctype_t);
/*  --------- The preceding functions are OBSOLETE --------- */

# _WCTYPE_DEFINED
#
#  /* ndef _MAC */


/* the character classification macro definitions */

#δ _CTYPE_DISABLE_MACROS

/*
 * Maximum number of bytes in multi-byte character in the current locale
 * (also defined in stdlib.h).
 */
#δ MB_CUR_MAX

# MB_CUR_MAX __mb_cur_max
_CRTIMP ⲿ  __mb_cur_max;

#  /* MB_CUR_MAX */

#Ѷ  _MAC

#δ __cplusplus
# isalpha(_c)     ( _pctype[_c] & (_UPPER|_LOWER) )
# isupper(_c)     ( _pctype[_c] & _UPPER )
# islower(_c)     ( _pctype[_c] & _LOWER )
# isdigit(_c)     ( _pctype[_c] & _DIGIT )
# isxdigit(_c)    ( _pctype[_c] & _HEX )
# isspace(_c)     ( _pctype[_c] & _SPACE )
# ispunct(_c)     ( _pctype[_c] & _PUNCT )
# isalnum(_c)     ( _pctype[_c] & (_UPPER|_LOWER|_DIGIT) )
# isprint(_c)     ( _pctype[_c] & (_BLANK|_PUNCT|_UPPER|_LOWER|_DIGIT) )
# isgraph(_c)     ( _pctype[_c] & (_PUNCT|_UPPER|_LOWER|_DIGIT) )
# iscntrl(_c)     ( _pctype[_c] & _CONTROL )
# 0         /* Pending ANSI C++ integration */
  isalpha( _C)      { (_pctype[_C] & (_UPPER|_LOWER)); }
  isupper( _C)      { (_pctype[_C] & _UPPER); }
  islower( _C)      { (_pctype[_C] & _LOWER); }
  isdigit( _C)      { (_pctype[_C] & _DIGIT); }
  isxdigit( _C)     { (_pctype[_C] & _HEX); }
  isspace( _C)      { (_pctype[_C] & _SPACE); }
  ispunct( _C)      { (_pctype[_C] & _PUNCT); }
  isalnum( _C)      { (_pctype[_C] & (_UPPER|_LOWER|_DIGIT)); }
  isprint( _C)
        { (_pctype[_C] & (_BLANK|_PUNCT|_UPPER|_LOWER|_DIGIT)); }
  isgraph( _C)
        { (_pctype[_C] & (_PUNCT|_UPPER|_LOWER|_DIGIT)); }
  iscntrl( _C)      { (_pctype[_C] & _CONTROL); }
#  /* __cplusplus */

#   /* ndef _MAC */

#δ __cplusplus
# isalpha(_c)     (MB_CUR_MAX > 1 ? _isctype(_c,_ALPHA) : _pctype[_c] & _ALPHA)
# isupper(_c)     (MB_CUR_MAX > 1 ? _isctype(_c,_UPPER) : _pctype[_c] & _UPPER)
# islower(_c)     (MB_CUR_MAX > 1 ? _isctype(_c,_LOWER) : _pctype[_c] & _LOWER)
# isdigit(_c)     (MB_CUR_MAX > 1 ? _isctype(_c,_DIGIT) : _pctype[_c] & _DIGIT)
# isxdigit(_c)    (MB_CUR_MAX > 1 ? _isctype(_c,_HEX)   : _pctype[_c] & _HEX)
# isspace(_c)     (MB_CUR_MAX > 1 ? _isctype(_c,_SPACE) : _pctype[_c] & _SPACE)
# ispunct(_c)     (MB_CUR_MAX > 1 ? _isctype(_c,_PUNCT) : _pctype[_c] & _PUNCT)
# isalnum(_c)     (MB_CUR_MAX > 1 ? _isctype(_c,_ALPHA|_DIGIT) : _pctype[_c] & (_ALPHA|_DIGIT))
# isprint(_c)     (MB_CUR_MAX > 1 ? _isctype(_c,_BLANK|_PUNCT|_ALPHA|_DIGIT) : _pctype[_c] & (_BLANK|_PUNCT|_ALPHA|_DIGIT))
# isgraph(_c)     (MB_CUR_MAX > 1 ? _isctype(_c,_PUNCT|_ALPHA|_DIGIT) : _pctype[_c] & (_PUNCT|_ALPHA|_DIGIT))
# iscntrl(_c)     (MB_CUR_MAX > 1 ? _isctype(_c,_CONTROL) : _pctype[_c] & _CONTROL)
#   0         /* Pending ANSI C++ integration */
  isalpha( _C)
        { (MB_CUR_MAX > 1 ? _isctype(_C,_ALPHA) : _pctype[_C] & _ALPHA); }
  isupper( _C)
        { (MB_CUR_MAX > 1 ? _isctype(_C,_UPPER) : _pctype[_C] & _UPPER); }
  islower( _C)
        { (MB_CUR_MAX > 1 ? _isctype(_C,_LOWER) : _pctype[_C] & _LOWER); }
  isdigit( _C)
        { (MB_CUR_MAX > 1 ? _isctype(_C,_DIGIT) : _pctype[_C] & _DIGIT); }
  isxdigit( _C)
        { (MB_CUR_MAX > 1 ? _isctype(_C,_HEX)   : _pctype[_C] & _HEX); }
  isspace( _C)
        { (MB_CUR_MAX > 1 ? _isctype(_C,_SPACE) : _pctype[_C] & _SPACE); }
  ispunct( _C)
        { (MB_CUR_MAX > 1 ? _isctype(_C,_PUNCT) : _pctype[_C] & _PUNCT); }
  isalnum( _C)
        { (MB_CUR_MAX > 1 ? _isctype(_C,_ALPHA|_DIGIT)
                : _pctype[_C] & (_ALPHA|_DIGIT)); }
  isprint( _C)
        { (MB_CUR_MAX > 1 ? _isctype(_C,_BLANK|_PUNCT|_ALPHA|_DIGIT)
                : _pctype[_C] & (_BLANK|_PUNCT|_ALPHA|_DIGIT)); }
  isgraph( _C)
        { (MB_CUR_MAX > 1 ? _isctype(_C,_PUNCT|_ALPHA|_DIGIT)
                : _pctype[_C] & (_PUNCT|_ALPHA|_DIGIT)); }
  iscntrl( _C)
        { (MB_CUR_MAX > 1 ? _isctype(_C,_CONTROL)
                : _pctype[_C] & _CONTROL); }
#  /* __cplusplus */

#  /* _MAC */

# _tolower(_c)    ( (_c)-'A'+'a' )
# _toupper(_c)    ( (_c)-'a'+'A' )

# __isascii(_c)   ( (޷)(_c) < 0x80 )
# __toascii(_c)   ( (_c) & 0x7f )

#δ _WCTYPE_INLINE_DEFINED
#δ __cplusplus
# iswalpha(_c)    ( iswctype(_c,_ALPHA) )
# iswupper(_c)    ( iswctype(_c,_UPPER) )
# iswlower(_c)    ( iswctype(_c,_LOWER) )
# iswdigit(_c)    ( iswctype(_c,_DIGIT) )
# iswxdigit(_c)   ( iswctype(_c,_HEX) )
# iswspace(_c)    ( iswctype(_c,_SPACE) )
# iswpunct(_c)    ( iswctype(_c,_PUNCT) )
# iswalnum(_c)    ( iswctype(_c,_ALPHA|_DIGIT) )
# iswprint(_c)    ( iswctype(_c,_BLANK|_PUNCT|_ALPHA|_DIGIT) )
# iswgraph(_c)    ( iswctype(_c,_PUNCT|_ALPHA|_DIGIT) )
# iswcntrl(_c)    ( iswctype(_c,_CONTROL) )
# iswascii(_c)    ( (޷)(_c) < 0x80 )
# isleadbyte(_c)  (_pctype[(޷ ַ)(_c)] & _LEADBYTE)
#   0         /* __cplusplus */
  iswalpha(wint_t _C) { (iswctype(_C,_ALPHA)); }
  iswupper(wint_t _C) { (iswctype(_C,_UPPER)); }
  iswlower(wint_t _C) { (iswctype(_C,_LOWER)); }
  iswdigit(wint_t _C) { (iswctype(_C,_DIGIT)); }
  iswxdigit(wint_t _C) { (iswctype(_C,_HEX)); }
  iswspace(wint_t _C) { (iswctype(_C,_SPACE)); }
  iswpunct(wint_t _C) { (iswctype(_C,_PUNCT)); }
  iswalnum(wint_t _C) { (iswctype(_C,_ALPHA|_DIGIT)); }
  iswprint(wint_t _C)
        { (iswctype(_C,_BLANK|_PUNCT|_ALPHA|_DIGIT)); }
  iswgraph(wint_t _C)
        { (iswctype(_C,_PUNCT|_ALPHA|_DIGIT)); }
  iswcntrl(wint_t _C) { (iswctype(_C,_CONTROL)); }
  iswascii(wint_t _C) { ((޷)(_C) < 0x80); }

  isleadbyte( _C)
        { (_pctype[(޷ ַ)(_C)] & _LEADBYTE); }
#  /* __cplusplus */
# _WCTYPE_INLINE_DEFINED
#  /* _WCTYPE_INLINE_DEFINED */

/* MS C version 2.0 extended ctype macros */

# __iscsymf(_c)   (isalpha(_c) || ((_c) == '_'))
# __iscsym(_c)    (isalnum(_c) || ((_c) == '_'))

#  /* _CTYPE_DISABLE_MACROS */


#     !__STDC__

/* Non-ANSI names ѭ compatibility */

#δ _CTYPE_DEFINED
_CRTIMP  ϰ isascii();
_CRTIMP  ϰ toascii();
_CRTIMP  ϰ iscsymf();
_CRTIMP  ϰ iscsym();
#
# isascii __isascii
# toascii __toascii
# iscsymf __iscsymf
# iscsym  __iscsym
#

#  /* __STDC__ */

#Ѷ  __cplusplus
}
#


#  /* _INC_CTYPE */
