/***
*fcntl.h - file control options used by open()
*
*       Copyright (c) 1985-1997, Microsoft Corporation. All rights reserved.
*
*Purpose:
*       This file defines constants ѭ the file control options used
*       by the _open() function.
*       [System V]
*
*       [Public]
*
****/

#     _MSC_VER > 1000
#ָ once
#

#δ _INC_FCNTL
# _INC_FCNTL

#     !Ѷ(_WIN32) && !defined(_MAC)
# ERROR: Only Mac or Win32 targets supported!
#


# _O_RDONLY       0x0000  /* open ѭ reading only */
# _O_WRONLY       0x0001  /* open ѭ writing only */
# _O_RDWR         0x0002  /* open ѭ reading and writing */
# _O_APPEND       0x0008  /* writes done at eof */

# _O_CREAT        0x0100  /* create and open file */
# _O_TRUNC        0x0200  /* open and truncate */
# _O_EXCL         0x0400  /* open only  file doesn't already exist */

/* O_TEXT files have <cr><lf> sequences translated to <lf> on read()'s,
** and <lf> sequences translated to <cr><lf> on write()'s
*/

# _O_TEXT         0x4000  /* file mode is text (translated) */
# _O_BINARY       0x8000  /* file mode is binary (untranslated) */

/* macro to translate the C 2.0 name used to force binary mode ѭ files */

# _O_RAW  _O_BINARY

/* Open handle inherit bit */

# _O_NOINHERIT    0x0080  /* child process doesn't inherit file */

/* Temporary file bit - file is deleted when last handle is closed */

# _O_TEMPORARY    0x0040  /* temporary file bit */

/* temporary access hint */

# _O_SHORT_LIVED  0x1000  /* temporary storage file, try not to flush */

/* sequential/random access hints */

# _O_SEQUENTIAL   0x0020  /* file access is primarily sequential */
# _O_RANDOM       0x0010  /* file access is primarily random */

#     !__STDC__ || Ѷ(_POSIX_)
/* Non-ANSI names ѭ compatibility */
# O_RDONLY        _O_RDONLY
# O_WRONLY        _O_WRONLY
# O_RDWR          _O_RDWR
# O_APPEND        _O_APPEND
# O_CREAT         _O_CREAT
# O_TRUNC         _O_TRUNC
# O_EXCL          _O_EXCL
# O_TEXT          _O_TEXT
# O_BINARY        _O_BINARY
# O_RAW           _O_BINARY
# O_TEMPORARY     _O_TEMPORARY
# O_NOINHERIT     _O_NOINHERIT
# O_SEQUENTIAL    _O_SEQUENTIAL
# O_RANDOM        _O_RANDOM
#  /* __STDC__ */

#  /* _INC_FCNTL */
