/***
*fstream.h - definitions/declarations ѭ filebuf and fstream classes
*
*       Copyright (c) 1991-1997, Microsoft Corporation.  All rights reserved.
*
*Purpose:
*       This file defines the classes, values, macros, and functions
*       used by the filebuf and fstream classes.
*       [AT&T C++]
*
*       [Public]
*
****/

#     _MSC_VER > 1000
#ָ once
#

#Ѷ  __cplusplus

#δ _INC_FSTREAM
# _INC_FSTREAM

#     !Ѷ(_WIN32) && !defined(_MAC)
# ERROR: Only Mac or Win32 targets supported!
#


#Ѷ  _MSC_VER
// Currently, all MS C compilers ѭ Win32 platforms ֵ to 8 byte
// alignment.
#ָ pack(push,8)

# <useoldio.h>

#  // _MSC_VER

/* Define _CRTIMP */

#δ _CRTIMP
#Ѷ  _DLL
# _CRTIMP __declspec(dllimport)
#   /* ndef _DLL */
# _CRTIMP
#  /* _DLL */
#  /* _CRTIMP */


# <iostream.h>

#Ѷ  _MSC_VER
// C4514: "unreferenced inline function has been removed"
#ָ warning(disable:4514) // disable C4514 warning
// #ָ warning(ֵ:4514)        // use this to reenable,  desired
#  // _MSC_VER

Ͷ  filedesc;

class _CRTIMP filebuf : public streambuf {
public:
̬  ֻ        openprot;       // ֵ share/prot mode ѭ open

// optional share values ѭ 3rd argument (prot) of open or constructor
̬  ֻ        sh_none;        // exclusive mode no sharing
̬  ֻ        sh_read;        // allow read sharing
̬  ֻ        sh_write;       // allow write sharing
// use (sh_read | sh_write) to allow both read and write sharing

// options ѭ setmode member function
̬  ֻ        binary;
̬  ֻ        text;

                        filebuf();
                        filebuf(filedesc);
                        filebuf(filedesc, ַ *, );
                        ~filebuf();

        filebuf*        attach(filedesc);
        filedesc        fd() ֻ {  (x_fd==-1) ? EOF : x_fd; }
                     is_open() ֻ {  (x_fd!=-1); }
        filebuf*        open(ֻ ַ *, ,  = filebuf::openprot);
        filebuf*        close();
                     setmode( = filebuf::text);

virtual              overflow(=EOF);
virtual              underflow();

virtual streambuf*      setbuf(ַ *, );
virtual streampos       seekoff(streamoff, ios::seek_dir, );
// virtual      streampos       seekpos(streampos, );
virtual              sync();

private:
        filedesc        x_fd;
                     x_fOpened;
};

class _CRTIMP ifstream : public istream {
public:
        ifstream();
        ifstream(ֻ ַ *,  =ios::in,  = filebuf::openprot);
        ifstream(filedesc);
        ifstream(filedesc, ַ *, );
        ~ifstream();

        streambuf * setbuf(ַ *, );
        filebuf* rdbuf() ֻ {  (filebuf*) ios::rdbuf(); }

         attach(filedesc);
        filedesc fd() ֻ {  rdbuf()->fd(); }

         is_open() ֻ {  rdbuf()->is_open(); }
         open(ֻ ַ *,  =ios::in,  = filebuf::openprot);
         close();
         setmode( mode = filebuf::text) {  rdbuf()->setmode(mode); }
};

class _CRTIMP ofstream : public ostream {
public:
        ofstream();
        ofstream(ֻ ַ *,  =ios::out,  = filebuf::openprot);
        ofstream(filedesc);
        ofstream(filedesc, ַ *, );
        ~ofstream();

        streambuf * setbuf(ַ *, );
        filebuf* rdbuf() ֻ {  (filebuf*) ios::rdbuf(); }

         attach(filedesc);
        filedesc fd() ֻ {  rdbuf()->fd(); }

         is_open() ֻ {  rdbuf()->is_open(); }
         open(ֻ ַ *,  =ios::out,  = filebuf::openprot);
         close();
         setmode( mode = filebuf::text) {  rdbuf()->setmode(mode); }
};
        
class _CRTIMP fstream : public iostream {
public:
        fstream();
        fstream(ֻ ַ *, ,  = filebuf::openprot);
        fstream(filedesc);
        fstream(filedesc, ַ *, );
        ~fstream();

        streambuf * setbuf(ַ *, );
        filebuf* rdbuf() ֻ {  (filebuf*) ostream::rdbuf(); }

         attach(filedesc);
        filedesc fd() ֻ {  rdbuf()->fd(); }

         is_open() ֻ {  rdbuf()->is_open(); }
         open(ֻ ַ *, ,  = filebuf::openprot);
         close();
         setmode( mode = filebuf::text) {  rdbuf()->setmode(mode); }
};
        
// manipulators to dynamically change file access mode (filebufs only)
  ios& binary(ios& _fstrm) \
   { ((filebuf*)_fstrm.rdbuf())->setmode(filebuf::binary);  _fstrm; }
  ios& text(ios& _fstrm) \
   { ((filebuf*)_fstrm.rdbuf())->setmode(filebuf::text);  _fstrm; }

#Ѷ  _MSC_VER
#ָ pack(pop)
#  // _MSC_VER

#  // _INC_FSTREAM

#  /* __cplusplus */
