#ifndef __GL_H__
# __GL_H__

#ifdef __cplusplus
extern "C" {
#endif

#ifndef WINGDIAPI
#  WINGDIAPI
#endif

#ifndef APIENTRY
# APIENTRY      _׼  
#endif

#ifdef UNICODE
#ȡ UNICODE
#endif

/*
** Copyright 1996 Silicon Graphics, Inc.
** All Rights Reserved.
**
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of Silicon Graphics, Inc.
**
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
*/

Ͷ unsigned int   GLenum;
Ͷ unsigned char  GLboolean;
Ͷ unsigned int   GLbitfield;
Ͷ signed char    GLbyte;
Ͷ short          GLshort;
Ͷ int            GLint;
Ͷ int            GLsizei;
Ͷ unsigned char  GLubyte;
Ͷ unsigned short GLushort;
Ͷ unsigned int   GLuint;
Ͷ float          GLfloat;
Ͷ float          GLclampf;
Ͷ double         GLdouble;
Ͷ double         GLclampd;
Ͷ void           GLvoid;

/*************************************************************/

/* Version */
# GL_VERSION_1_1                    1

/* AccumOp */
# GL_ACCUM                          0x0100
# GL_LOAD                           0x0101
# GL_RETURN                         0x0102
# GL_MULT                           0x0103
# GL_ADD                            0x0104

/* AlphaFunction */
# GL_NEVER                          0x0200
# GL_LESS                           0x0201
# GL_EQUAL                          0x0202
# GL_LEQUAL                         0x0203
# GL_GREATER                        0x0204
# GL_NOTEQUAL                       0x0205
# GL_GEQUAL                         0x0206
# GL_ALWAYS                         0x0207

/* AttribMask */
# GL_CURRENT_BIT                    0x00000001
# GL_POINT_BIT                      0x00000002
# GL_LINE_BIT                       0x00000004
# GL_POLYGON_BIT                    0x00000008
# GL_POLYGON_STIPPLE_BIT            0x00000010
# GL_PIXEL_MODE_BIT                 0x00000020
# GL_LIGHTING_BIT                   0x00000040
# GL_FOG_BIT                        0x00000080
# GL_DEPTH_BUFFER_BIT               0x00000100
# GL_ACCUM_BUFFER_BIT               0x00000200
# GL_STENCIL_BUFFER_BIT             0x00000400
# GL_VIEWPORT_BIT                   0x00000800
# GL_TRANSFORM_BIT                  0x00001000
# GL_ENABLE_BIT                     0x00002000
# GL_COLOR_BUFFER_BIT               0x00004000
# GL_HINT_BIT                       0x00008000
# GL_EVAL_BIT                       0x00010000
# GL_LIST_BIT                       0x00020000
# GL_TEXTURE_BIT                    0x00040000
# GL_SCISSOR_BIT                    0x00080000
# GL_ALL_ATTRIB_BITS                0x000fffff

/* BeginMode */
# GL_POINTS                         0x0000
# GL_LINES                          0x0001
# GL_LINE_LOOP                      0x0002
# GL_LINE_STRIP                     0x0003
# GL_TRIANGLES                      0x0004
# GL_TRIANGLE_STRIP                 0x0005
# GL_TRIANGLE_FAN                   0x0006
# GL_QUADS                          0x0007
# GL_QUAD_STRIP                     0x0008
# GL_POLYGON                        0x0009

/* BlendingFactorDest */
# GL_ZERO                           0
# GL_ONE                            1
# GL_SRC_COLOR                      0x0300
# GL_ONE_MINUS_SRC_COLOR            0x0301
# GL_SRC_ALPHA                      0x0302
# GL_ONE_MINUS_SRC_ALPHA            0x0303
# GL_DST_ALPHA                      0x0304
# GL_ONE_MINUS_DST_ALPHA            0x0305

/* BlendingFactorSrc */
/*      GL_ZERO */
/*      GL_ONE */
# GL_DST_COLOR                      0x0306
# GL_ONE_MINUS_DST_COLOR            0x0307
# GL_SRC_ALPHA_SATURATE             0x0308
/*      GL_SRC_ALPHA */
/*      GL_ONE_MINUS_SRC_ALPHA */
/*      GL_DST_ALPHA */
/*      GL_ONE_MINUS_DST_ALPHA */

/* Boolean */
# GL_TRUE                           1
# GL_FALSE                          0

/* ClearBufferMask */
/*      GL_COLOR_BUFFER_BIT */
/*      GL_ACCUM_BUFFER_BIT */
/*      GL_STENCIL_BUFFER_BIT */
/*      GL_DEPTH_BUFFER_BIT */

/* ClientArrayType */
/*      GL_VERTEX_ARRAY */
/*      GL_NORMAL_ARRAY */
/*      GL_COLOR_ARRAY */
/*      GL_INDEX_ARRAY */
/*      GL_TEXTURE_COORD_ARRAY */
/*      GL_EDGE_FLAG_ARRAY */

/* ClipPlaneName */
# GL_CLIP_PLANE0                    0x3000
# GL_CLIP_PLANE1                    0x3001
# GL_CLIP_PLANE2                    0x3002
# GL_CLIP_PLANE3                    0x3003
# GL_CLIP_PLANE4                    0x3004
# GL_CLIP_PLANE5                    0x3005

/* ColorMaterialFace */
/*      GL_FRONT */
/*      GL_BACK */
/*      GL_FRONT_AND_BACK */

/* ColorMaterialParameter */
/*      GL_AMBIENT */
/*      GL_DIFFUSE */
/*      GL_SPECULAR */
/*      GL_EMISSION */
/*      GL_AMBIENT_AND_DIFFUSE */

/* ColorPointerType */
/*      GL_BYTE */
/*      GL_UNSIGNED_BYTE */
/*      GL_SHORT */
/*      GL_UNSIGNED_SHORT */
/*      GL_INT */
/*      GL_UNSIGNED_INT */
/*      GL_FLOAT */
/*      GL_DOUBLE */

/* CullFaceMode */
/*      GL_FRONT */
/*      GL_BACK */
/*      GL_FRONT_AND_BACK */

/* DataType */
# GL_BYTE                           0x1400
# GL_UNSIGNED_BYTE                  0x1401
# GL_SHORT                          0x1402
# GL_UNSIGNED_SHORT                 0x1403
# GL_INT                            0x1404
# GL_UNSIGNED_INT                   0x1405
# GL_FLOAT                          0x1406
# GL_2_BYTES                        0x1407
# GL_3_BYTES                        0x1408
# GL_4_BYTES                        0x1409
# GL_DOUBLE                         0x140A

/* DepthFunction */
/*      GL_NEVER */
/*      GL_LESS */
/*      GL_EQUAL */
/*      GL_LEQUAL */
/*      GL_GREATER */
/*      GL_NOTEQUAL */
/*      GL_GEQUAL */
/*      GL_ALWAYS */

/* DrawBufferMode */
# GL_NONE                           0
# GL_FRONT_LEFT                     0x0400
# GL_FRONT_RIGHT                    0x0401
# GL_BACK_LEFT                      0x0402
# GL_BACK_RIGHT                     0x0403
# GL_FRONT                          0x0404
# GL_BACK                           0x0405
# GL_LEFT                           0x0406
# GL_RIGHT                          0x0407
# GL_FRONT_AND_BACK                 0x0408
# GL_AUX0                           0x0409
# GL_AUX1                           0x040A
# GL_AUX2                           0x040B
# GL_AUX3                           0x040C

/* Enable */
/*      GL_FOG */
/*      GL_LIGHTING */
/*      GL_TEXTURE_1D */
/*      GL_TEXTURE_2D */
/*      GL_LINE_STIPPLE */
/*      GL_POLYGON_STIPPLE */
/*      GL_CULL_FACE */
/*      GL_ALPHA_TEST */
/*      GL_BLEND */
/*      GL_INDEX_LOGIC_OP */
/*      GL_COLOR_LOGIC_OP */
/*      GL_DITHER */
/*      GL_STENCIL_TEST */
/*      GL_DEPTH_TEST */
/*      GL_CLIP_PLANE0 */
/*      GL_CLIP_PLANE1 */
/*      GL_CLIP_PLANE2 */
/*      GL_CLIP_PLANE3 */
/*      GL_CLIP_PLANE4 */
/*      GL_CLIP_PLANE5 */
/*      GL_LIGHT0 */
/*      GL_LIGHT1 */
/*      GL_LIGHT2 */
/*      GL_LIGHT3 */
/*      GL_LIGHT4 */
/*      GL_LIGHT5 */
/*      GL_LIGHT6 */
/*      GL_LIGHT7 */
/*      GL_TEXTURE_GEN_S */
/*      GL_TEXTURE_GEN_T */
/*      GL_TEXTURE_GEN_R */
/*      GL_TEXTURE_GEN_Q */
/*      GL_MAP1_VERTEX_3 */
/*      GL_MAP1_VERTEX_4 */
/*      GL_MAP1_COLOR_4 */
/*      GL_MAP1_INDEX */
/*      GL_MAP1_NORMAL */
/*      GL_MAP1_TEXTURE_COORD_1 */
/*      GL_MAP1_TEXTURE_COORD_2 */
/*      GL_MAP1_TEXTURE_COORD_3 */
/*      GL_MAP1_TEXTURE_COORD_4 */
/*      GL_MAP2_VERTEX_3 */
/*      GL_MAP2_VERTEX_4 */
/*      GL_MAP2_COLOR_4 */
/*      GL_MAP2_INDEX */
/*      GL_MAP2_NORMAL */
/*      GL_MAP2_TEXTURE_COORD_1 */
/*      GL_MAP2_TEXTURE_COORD_2 */
/*      GL_MAP2_TEXTURE_COORD_3 */
/*      GL_MAP2_TEXTURE_COORD_4 */
/*      GL_POINT_SMOOTH */
/*      GL_LINE_SMOOTH */
/*      GL_POLYGON_SMOOTH */
/*      GL_SCISSOR_TEST */
/*      GL_COLOR_MATERIAL */
/*      GL_NORMALIZE */
/*      GL_AUTO_NORMAL */
/*      GL_VERTEX_ARRAY */
/*      GL_NORMAL_ARRAY */
/*      GL_COLOR_ARRAY */
/*      GL_INDEX_ARRAY */
/*      GL_TEXTURE_COORD_ARRAY */
/*      GL_EDGE_FLAG_ARRAY */
/*      GL_POLYGON_OFFSET_POINT */
/*      GL_POLYGON_OFFSET_LINE */
/*      GL_POLYGON_OFFSET_FILL */

/* ErrorCode */
# GL_NO_ERROR                       0
# GL_INVALID_ENUM                   0x0500
# GL_INVALID_VALUE                  0x0501
# GL_INVALID_OPERATION              0x0502
# GL_STACK_OVERFLOW                 0x0503
# GL_STACK_UNDERFLOW                0x0504
# GL_OUT_OF_MEMORY                  0x0505

/* FeedBackMode */
# GL_2D                             0x0600
# GL_3D                             0x0601
# GL_3D_COLOR                       0x0602
# GL_3D_COLOR_TEXTURE               0x0603
# GL_4D_COLOR_TEXTURE               0x0604

/* FeedBackToken */
# GL_PASS_THROUGH_TOKEN             0x0700
# GL_POINT_TOKEN                    0x0701
# GL_LINE_TOKEN                     0x0702
# GL_POLYGON_TOKEN                  0x0703
# GL_BITMAP_TOKEN                   0x0704
# GL_DRAW_PIXEL_TOKEN               0x0705
# GL_COPY_PIXEL_TOKEN               0x0706
# GL_LINE_RESET_TOKEN               0x0707

/* FogMode */
/*      GL_LINEAR */
# GL_EXP                            0x0800
# GL_EXP2                           0x0801


/* FogParameter */
/*      GL_FOG_COLOR */
/*      GL_FOG_DENSITY */
/*      GL_FOG_END */
/*      GL_FOG_INDEX */
/*      GL_FOG_MODE */
/*      GL_FOG_START */

/* FrontFaceDirection */
# GL_CW                             0x0900
# GL_CCW                            0x0901

/* GetMapTarget */
# GL_COEFF                          0x0A00
# GL_ORDER                          0x0A01
# GL_DOMAIN                         0x0A02

/* GetPixelMap */
/*      GL_PIXEL_MAP_I_TO_I */
/*      GL_PIXEL_MAP_S_TO_S */
/*      GL_PIXEL_MAP_I_TO_R */
/*      GL_PIXEL_MAP_I_TO_G */
/*      GL_PIXEL_MAP_I_TO_B */
/*      GL_PIXEL_MAP_I_TO_A */
/*      GL_PIXEL_MAP_R_TO_R */
/*      GL_PIXEL_MAP_G_TO_G */
/*      GL_PIXEL_MAP_B_TO_B */
/*      GL_PIXEL_MAP_A_TO_A */

/* GetPointerTarget */
/*      GL_VERTEX_ARRAY_POINTER */
/*      GL_NORMAL_ARRAY_POINTER */
/*      GL_COLOR_ARRAY_POINTER */
/*      GL_INDEX_ARRAY_POINTER */
/*      GL_TEXTURE_COORD_ARRAY_POINTER */
/*      GL_EDGE_FLAG_ARRAY_POINTER */

/* GetTarget */
# GL_CURRENT_COLOR                  0x0B00
# GL_CURRENT_INDEX                  0x0B01
# GL_CURRENT_NORMAL                 0x0B02
# GL_CURRENT_TEXTURE_COORDS         0x0B03
# GL_CURRENT_RASTER_COLOR           0x0B04
# GL_CURRENT_RASTER_INDEX           0x0B05
# GL_CURRENT_RASTER_TEXTURE_COORDS  0x0B06
# GL_CURRENT_RASTER_POSITION        0x0B07
# GL_CURRENT_RASTER_POSITION_VALID  0x0B08
# GL_CURRENT_RASTER_DISTANCE        0x0B09
# GL_POINT_SMOOTH                   0x0B10
# GL_POINT_SIZE                     0x0B11
# GL_POINT_SIZE_RANGE               0x0B12
# GL_POINT_SIZE_GRANULARITY         0x0B13
# GL_LINE_SMOOTH                    0x0B20
# GL_LINE_WIDTH                     0x0B21
# GL_LINE_WIDTH_RANGE               0x0B22
# GL_LINE_WIDTH_GRANULARITY         0x0B23
# GL_LINE_STIPPLE                   0x0B24
# GL_LINE_STIPPLE_PATTERN           0x0B25
# GL_LINE_STIPPLE_REPEAT            0x0B26
# GL_LIST_MODE                      0x0B30
# GL_MAX_LIST_NESTING               0x0B31
# GL_LIST_BASE                      0x0B32
# GL_LIST_INDEX                     0x0B33
# GL_POLYGON_MODE                   0x0B40
# GL_POLYGON_SMOOTH                 0x0B41
# GL_POLYGON_STIPPLE                0x0B42
# GL_EDGE_FLAG                      0x0B43
# GL_CULL_FACE                      0x0B44
# GL_CULL_FACE_MODE                 0x0B45
# GL_FRONT_FACE                     0x0B46
# GL_LIGHTING                       0x0B50
# GL_LIGHT_MODEL_LOCAL_VIEWER       0x0B51
# GL_LIGHT_MODEL_TWO_SIDE           0x0B52
# GL_LIGHT_MODEL_AMBIENT            0x0B53
# GL_SHADE_MODEL                    0x0B54
# GL_COLOR_MATERIAL_FACE            0x0B55
# GL_COLOR_MATERIAL_PARAMETER       0x0B56
# GL_COLOR_MATERIAL                 0x0B57
# GL_FOG                            0x0B60
# GL_FOG_INDEX                      0x0B61
# GL_FOG_DENSITY                    0x0B62
# GL_FOG_START                      0x0B63
# GL_FOG_END                        0x0B64
# GL_FOG_MODE                       0x0B65
# GL_FOG_COLOR                      0x0B66
# GL_DEPTH_RANGE                    0x0B70
# GL_DEPTH_TEST                     0x0B71
# GL_DEPTH_WRITEMASK                0x0B72
# GL_DEPTH_CLEAR_VALUE              0x0B73
# GL_DEPTH_FUNC                     0x0B74
# GL_ACCUM_CLEAR_VALUE              0x0B80
# GL_STENCIL_TEST                   0x0B90
# GL_STENCIL_CLEAR_VALUE            0x0B91
# GL_STENCIL_FUNC                   0x0B92
# GL_STENCIL_VALUE_MASK             0x0B93
# GL_STENCIL_FAIL                   0x0B94
# GL_STENCIL_PASS_DEPTH_FAIL        0x0B95
# GL_STENCIL_PASS_DEPTH_PASS        0x0B96
# GL_STENCIL_REF                    0x0B97
# GL_STENCIL_WRITEMASK              0x0B98
# GL_MATRIX_MODE                    0x0BA0
# GL_NORMALIZE                      0x0BA1
# GL_VIEWPORT                       0x0BA2
# GL_MODELVIEW_STACK_DEPTH          0x0BA3
# GL_PROJECTION_STACK_DEPTH         0x0BA4
# GL_TEXTURE_STACK_DEPTH            0x0BA5
# GL_MODELVIEW_MATRIX               0x0BA6
# GL_PROJECTION_MATRIX              0x0BA7
# GL_TEXTURE_MATRIX                 0x0BA8
# GL_ATTRIB_STACK_DEPTH             0x0BB0
# GL_CLIENT_ATTRIB_STACK_DEPTH      0x0BB1
# GL_ALPHA_TEST                     0x0BC0
# GL_ALPHA_TEST_FUNC                0x0BC1
# GL_ALPHA_TEST_REF                 0x0BC2
# GL_DITHER                         0x0BD0
# GL_BLEND_DST                      0x0BE0
# GL_BLEND_SRC                      0x0BE1
# GL_BLEND                          0x0BE2
# GL_LOGIC_OP_MODE                  0x0BF0
# GL_INDEX_LOGIC_OP                 0x0BF1
# GL_COLOR_LOGIC_OP                 0x0BF2
# GL_AUX_BUFFERS                    0x0C00
# GL_DRAW_BUFFER                    0x0C01
# GL_READ_BUFFER                    0x0C02
# GL_SCISSOR_BOX                    0x0C10
# GL_SCISSOR_TEST                   0x0C11
# GL_INDEX_CLEAR_VALUE              0x0C20
# GL_INDEX_WRITEMASK                0x0C21
# GL_COLOR_CLEAR_VALUE              0x0C22
# GL_COLOR_WRITEMASK                0x0C23
# GL_INDEX_MODE                     0x0C30
# GL_RGBA_MODE                      0x0C31
# GL_DOUBLEBUFFER                   0x0C32
# GL_STEREO                         0x0C33
# GL_RENDER_MODE                    0x0C40
# GL_PERSPECTIVE_CORRECTION_HINT    0x0C50
# GL_POINT_SMOOTH_HINT              0x0C51
# GL_LINE_SMOOTH_HINT               0x0C52
# GL_POLYGON_SMOOTH_HINT            0x0C53
# GL_FOG_HINT                       0x0C54
# GL_TEXTURE_GEN_S                  0x0C60
# GL_TEXTURE_GEN_T                  0x0C61
# GL_TEXTURE_GEN_R                  0x0C62
# GL_TEXTURE_GEN_Q                  0x0C63
# GL_PIXEL_MAP_I_TO_I               0x0C70
# GL_PIXEL_MAP_S_TO_S               0x0C71
# GL_PIXEL_MAP_I_TO_R               0x0C72
# GL_PIXEL_MAP_I_TO_G               0x0C73
# GL_PIXEL_MAP_I_TO_B               0x0C74
# GL_PIXEL_MAP_I_TO_A               0x0C75
# GL_PIXEL_MAP_R_TO_R               0x0C76
# GL_PIXEL_MAP_G_TO_G               0x0C77
# GL_PIXEL_MAP_B_TO_B               0x0C78
# GL_PIXEL_MAP_A_TO_A               0x0C79
# GL_PIXEL_MAP_I_TO_I_SIZE          0x0CB0
# GL_PIXEL_MAP_S_TO_S_SIZE          0x0CB1
# GL_PIXEL_MAP_I_TO_R_SIZE          0x0CB2
# GL_PIXEL_MAP_I_TO_G_SIZE          0x0CB3
# GL_PIXEL_MAP_I_TO_B_SIZE          0x0CB4
# GL_PIXEL_MAP_I_TO_A_SIZE          0x0CB5
# GL_PIXEL_MAP_R_TO_R_SIZE          0x0CB6
# GL_PIXEL_MAP_G_TO_G_SIZE          0x0CB7
# GL_PIXEL_MAP_B_TO_B_SIZE          0x0CB8
# GL_PIXEL_MAP_A_TO_A_SIZE          0x0CB9
# GL_UNPACK_SWAP_BYTES              0x0CF0
# GL_UNPACK_LSB_FIRST               0x0CF1
# GL_UNPACK_ROW_LENGTH              0x0CF2
# GL_UNPACK_SKIP_ROWS               0x0CF3
# GL_UNPACK_SKIP_PIXELS             0x0CF4
# GL_UNPACK_ALIGNMENT               0x0CF5
# GL_PACK_SWAP_BYTES                0x0D00
# GL_PACK_LSB_FIRST                 0x0D01
# GL_PACK_ROW_LENGTH                0x0D02
# GL_PACK_SKIP_ROWS                 0x0D03
# GL_PACK_SKIP_PIXELS               0x0D04
# GL_PACK_ALIGNMENT                 0x0D05
# GL_MAP_COLOR                      0x0D10
# GL_MAP_STENCIL                    0x0D11
# GL_INDEX_SHIFT                    0x0D12
# GL_INDEX_OFFSET                   0x0D13
# GL_RED_SCALE                      0x0D14
# GL_RED_BIAS                       0x0D15
# GL_ZOOM_X                         0x0D16
# GL_ZOOM_Y                         0x0D17
# GL_GREEN_SCALE                    0x0D18
# GL_GREEN_BIAS                     0x0D19
# GL_BLUE_SCALE                     0x0D1A
# GL_BLUE_BIAS                      0x0D1B
# GL_ALPHA_SCALE                    0x0D1C
# GL_ALPHA_BIAS                     0x0D1D
# GL_DEPTH_SCALE                    0x0D1E
# GL_DEPTH_BIAS                     0x0D1F
# GL_MAX_EVAL_ORDER                 0x0D30
# GL_MAX_LIGHTS                     0x0D31
# GL_MAX_CLIP_PLANES                0x0D32
# GL_MAX_TEXTURE_SIZE               0x0D33
# GL_MAX_PIXEL_MAP_TABLE            0x0D34
# GL_MAX_ATTRIB_STACK_DEPTH         0x0D35
# GL_MAX_MODELVIEW_STACK_DEPTH      0x0D36
# GL_MAX_NAME_STACK_DEPTH           0x0D37
# GL_MAX_PROJECTION_STACK_DEPTH     0x0D38
# GL_MAX_TEXTURE_STACK_DEPTH        0x0D39
# GL_MAX_VIEWPORT_DIMS              0x0D3A
# GL_MAX_CLIENT_ATTRIB_STACK_DEPTH  0x0D3B
# GL_SUBPIXEL_BITS                  0x0D50
# GL_INDEX_BITS                     0x0D51
# GL_RED_BITS                       0x0D52
# GL_GREEN_BITS                     0x0D53
# GL_BLUE_BITS                      0x0D54
# GL_ALPHA_BITS                     0x0D55
# GL_DEPTH_BITS                     0x0D56
# GL_STENCIL_BITS                   0x0D57
# GL_ACCUM_RED_BITS                 0x0D58
# GL_ACCUM_GREEN_BITS               0x0D59
# GL_ACCUM_BLUE_BITS                0x0D5A
# GL_ACCUM_ALPHA_BITS               0x0D5B
# GL_NAME_STACK_DEPTH               0x0D70
# GL_AUTO_NORMAL                    0x0D80
# GL_MAP1_COLOR_4                   0x0D90
# GL_MAP1_INDEX                     0x0D91
# GL_MAP1_NORMAL                    0x0D92
# GL_MAP1_TEXTURE_COORD_1           0x0D93
# GL_MAP1_TEXTURE_COORD_2           0x0D94
# GL_MAP1_TEXTURE_COORD_3           0x0D95
# GL_MAP1_TEXTURE_COORD_4           0x0D96
# GL_MAP1_VERTEX_3                  0x0D97
# GL_MAP1_VERTEX_4                  0x0D98
# GL_MAP2_COLOR_4                   0x0DB0
# GL_MAP2_INDEX                     0x0DB1
# GL_MAP2_NORMAL                    0x0DB2
# GL_MAP2_TEXTURE_COORD_1           0x0DB3
# GL_MAP2_TEXTURE_COORD_2           0x0DB4
# GL_MAP2_TEXTURE_COORD_3           0x0DB5
# GL_MAP2_TEXTURE_COORD_4           0x0DB6
# GL_MAP2_VERTEX_3                  0x0DB7
# GL_MAP2_VERTEX_4                  0x0DB8
# GL_MAP1_GRID_DOMAIN               0x0DD0
# GL_MAP1_GRID_SEGMENTS             0x0DD1
# GL_MAP2_GRID_DOMAIN               0x0DD2
# GL_MAP2_GRID_SEGMENTS             0x0DD3
# GL_TEXTURE_1D                     0x0DE0
# GL_TEXTURE_2D                     0x0DE1
# GL_FEEDBACK_BUFFER_POINTER        0x0DF0
# GL_FEEDBACK_BUFFER_SIZE           0x0DF1
# GL_FEEDBACK_BUFFER_TYPE           0x0DF2
# GL_SELECTION_BUFFER_POINTER       0x0DF3
# GL_SELECTION_BUFFER_SIZE          0x0DF4
/*      GL_TEXTURE_BINDING_1D */
/*      GL_TEXTURE_BINDING_2D */
/*      GL_VERTEX_ARRAY */
/*      GL_NORMAL_ARRAY */
/*      GL_COLOR_ARRAY */
/*      GL_INDEX_ARRAY */
/*      GL_TEXTURE_COORD_ARRAY */
/*      GL_EDGE_FLAG_ARRAY */
/*      GL_VERTEX_ARRAY_SIZE */
/*      GL_VERTEX_ARRAY_TYPE */
/*      GL_VERTEX_ARRAY_STRIDE */
/*      GL_NORMAL_ARRAY_TYPE */
/*      GL_NORMAL_ARRAY_STRIDE */
/*      GL_COLOR_ARRAY_SIZE */
/*      GL_COLOR_ARRAY_TYPE */
/*      GL_COLOR_ARRAY_STRIDE */
/*      GL_INDEX_ARRAY_TYPE */
/*      GL_INDEX_ARRAY_STRIDE */
/*      GL_TEXTURE_COORD_ARRAY_SIZE */
/*      GL_TEXTURE_COORD_ARRAY_TYPE */
/*      GL_TEXTURE_COORD_ARRAY_STRIDE */
/*      GL_EDGE_FLAG_ARRAY_STRIDE */
/*      GL_POLYGON_OFFSET_FACTOR */
/*      GL_POLYGON_OFFSET_UNITS */

/* GetTextureParameter */
/*      GL_TEXTURE_MAG_FILTER */
/*      GL_TEXTURE_MIN_FILTER */
/*      GL_TEXTURE_WRAP_S */
/*      GL_TEXTURE_WRAP_T */
# GL_TEXTURE_WIDTH                  0x1000
# GL_TEXTURE_HEIGHT                 0x1001
# GL_TEXTURE_INTERNAL_FORMAT        0x1003
# GL_TEXTURE_BORDER_COLOR           0x1004
# GL_TEXTURE_BORDER                 0x1005
/*      GL_TEXTURE_RED_SIZE */
/*      GL_TEXTURE_GREEN_SIZE */
/*      GL_TEXTURE_BLUE_SIZE */
/*      GL_TEXTURE_ALPHA_SIZE */
/*      GL_TEXTURE_LUMINANCE_SIZE */
/*      GL_TEXTURE_INTENSITY_SIZE */
/*      GL_TEXTURE_PRIORITY */
/*      GL_TEXTURE_RESIDENT */

/* HintMode */
# GL_DONT_CARE                      0x1100
# GL_FASTEST                        0x1101
# GL_NICEST                         0x1102

/* HintTarget */
/*      GL_PERSPECTIVE_CORRECTION_HINT */
/*      GL_POINT_SMOOTH_HINT */
/*      GL_LINE_SMOOTH_HINT */
/*      GL_POLYGON_SMOOTH_HINT */
/*      GL_FOG_HINT */
/*      GL_PHONG_HINT */

/* IndexPointerType */
/*      GL_SHORT */
/*      GL_INT */
/*      GL_FLOAT */
/*      GL_DOUBLE */

/* LightModelParameter */
/*      GL_LIGHT_MODEL_AMBIENT */
/*      GL_LIGHT_MODEL_LOCAL_VIEWER */
/*      GL_LIGHT_MODEL_TWO_SIDE */

/* LightName */
# GL_LIGHT0                         0x4000
# GL_LIGHT1                         0x4001
# GL_LIGHT2                         0x4002
# GL_LIGHT3                         0x4003
# GL_LIGHT4                         0x4004
# GL_LIGHT5                         0x4005
# GL_LIGHT6                         0x4006
# GL_LIGHT7                         0x4007

/* LightParameter */
# GL_AMBIENT                        0x1200
# GL_DIFFUSE                        0x1201
# GL_SPECULAR                       0x1202
# GL_POSITION                       0x1203
# GL_SPOT_DIRECTION                 0x1204
# GL_SPOT_EXPONENT                  0x1205
# GL_SPOT_CUTOFF                    0x1206
# GL_CONSTANT_ATTENUATION           0x1207
# GL_LINEAR_ATTENUATION             0x1208
# GL_QUADRATIC_ATTENUATION          0x1209

/* InterleavedArrays */
/*      GL_V2F */
/*      GL_V3F */
/*      GL_C4UB_V2F */
/*      GL_C4UB_V3F */
/*      GL_C3F_V3F */
/*      GL_N3F_V3F */
/*      GL_C4F_N3F_V3F */
/*      GL_T2F_V3F */
/*      GL_T4F_V4F */
/*      GL_T2F_C4UB_V3F */
/*      GL_T2F_C3F_V3F */
/*      GL_T2F_N3F_V3F */
/*      GL_T2F_C4F_N3F_V3F */
/*      GL_T4F_C4F_N3F_V4F */

/* ListMode */
# GL_COMPILE                        0x1300
# GL_COMPILE_AND_EXECUTE            0x1301

/* ListNameType */
/*      GL_BYTE */
/*      GL_UNSIGNED_BYTE */
/*      GL_SHORT */
/*      GL_UNSIGNED_SHORT */
/*      GL_INT */
/*      GL_UNSIGNED_INT */
/*      GL_FLOAT */
/*      GL_2_BYTES */
/*      GL_3_BYTES */
/*      GL_4_BYTES */

/* LogicOp */
# GL_CLEAR                          0x1500
# GL_AND                            0x1501
# GL_AND_REVERSE                    0x1502
# GL_COPY                           0x1503
# GL_AND_INVERTED                   0x1504
# GL_NOOP                           0x1505
# GL_XOR                            0x1506
# GL_OR                             0x1507
# GL_NOR                            0x1508
# GL_EQUIV                          0x1509
# GL_INVERT                         0x150A
# GL_OR_REVERSE                     0x150B
# GL_COPY_INVERTED                  0x150C
# GL_OR_INVERTED                    0x150D
# GL_NAND                           0x150E
# GL_SET                            0x150F

/* MapTarget */
/*      GL_MAP1_COLOR_4 */
/*      GL_MAP1_INDEX */
/*      GL_MAP1_NORMAL */
/*      GL_MAP1_TEXTURE_COORD_1 */
/*      GL_MAP1_TEXTURE_COORD_2 */
/*      GL_MAP1_TEXTURE_COORD_3 */
/*      GL_MAP1_TEXTURE_COORD_4 */
/*      GL_MAP1_VERTEX_3 */
/*      GL_MAP1_VERTEX_4 */
/*      GL_MAP2_COLOR_4 */
/*      GL_MAP2_INDEX */
/*      GL_MAP2_NORMAL */
/*      GL_MAP2_TEXTURE_COORD_1 */
/*      GL_MAP2_TEXTURE_COORD_2 */
/*      GL_MAP2_TEXTURE_COORD_3 */
/*      GL_MAP2_TEXTURE_COORD_4 */
/*      GL_MAP2_VERTEX_3 */
/*      GL_MAP2_VERTEX_4 */

/* MaterialFace */
/*      GL_FRONT */
/*      GL_BACK */
/*      GL_FRONT_AND_BACK */

/* MaterialParameter */
# GL_EMISSION                       0x1600
# GL_SHININESS                      0x1601
# GL_AMBIENT_AND_DIFFUSE            0x1602
# GL_COLOR_INDEXES                  0x1603
/*      GL_AMBIENT */
/*      GL_DIFFUSE */
/*      GL_SPECULAR */

/* MatrixMode */
# GL_MODELVIEW                      0x1700
# GL_PROJECTION                     0x1701
# GL_TEXTURE                        0x1702

/* MeshMode1 */
/*      GL_POINT */
/*      GL_LINE */

/* MeshMode2 */
/*      GL_POINT */
/*      GL_LINE */
/*      GL_FILL */

/* NormalPointerType */
/*      GL_BYTE */
/*      GL_SHORT */
/*      GL_INT */
/*      GL_FLOAT */
/*      GL_DOUBLE */

/* PixelCopyType */
# GL_COLOR                          0x1800
# GL_DEPTH                          0x1801
# GL_STENCIL                        0x1802

/* PixelFormat */
# GL_COLOR_INDEX                    0x1900
# GL_STENCIL_INDEX                  0x1901
# GL_DEPTH_COMPONENT                0x1902
# GL_RED                            0x1903
# GL_GREEN                          0x1904
# GL_BLUE                           0x1905
# GL_ALPHA                          0x1906
# GL_RGB                            0x1907
# GL_RGBA                           0x1908
# GL_LUMINANCE                      0x1909
# GL_LUMINANCE_ALPHA                0x190A

/* PixelMap */
/*      GL_PIXEL_MAP_I_TO_I */
/*      GL_PIXEL_MAP_S_TO_S */
/*      GL_PIXEL_MAP_I_TO_R */
/*      GL_PIXEL_MAP_I_TO_G */
/*      GL_PIXEL_MAP_I_TO_B */
/*      GL_PIXEL_MAP_I_TO_A */
/*      GL_PIXEL_MAP_R_TO_R */
/*      GL_PIXEL_MAP_G_TO_G */
/*      GL_PIXEL_MAP_B_TO_B */
/*      GL_PIXEL_MAP_A_TO_A */

/* PixelStore */
/*      GL_UNPACK_SWAP_BYTES */
/*      GL_UNPACK_LSB_FIRST */
/*      GL_UNPACK_ROW_LENGTH */
/*      GL_UNPACK_SKIP_ROWS */
/*      GL_UNPACK_SKIP_PIXELS */
/*      GL_UNPACK_ALIGNMENT */
/*      GL_PACK_SWAP_BYTES */
/*      GL_PACK_LSB_FIRST */
/*      GL_PACK_ROW_LENGTH */
/*      GL_PACK_SKIP_ROWS */
/*      GL_PACK_SKIP_PIXELS */
/*      GL_PACK_ALIGNMENT */

/* PixelTransfer */
/*      GL_MAP_COLOR */
/*      GL_MAP_STENCIL */
/*      GL_INDEX_SHIFT */
/*      GL_INDEX_OFFSET */
/*      GL_RED_SCALE */
/*      GL_RED_BIAS */
/*      GL_GREEN_SCALE */
/*      GL_GREEN_BIAS */
/*      GL_BLUE_SCALE */
/*      GL_BLUE_BIAS */
/*      GL_ALPHA_SCALE */
/*      GL_ALPHA_BIAS */
/*      GL_DEPTH_SCALE */
/*      GL_DEPTH_BIAS */

/* PixelType */
# GL_BITMAP                         0x1A00
/*      GL_BYTE */
/*      GL_UNSIGNED_BYTE */
/*      GL_SHORT */
/*      GL_UNSIGNED_SHORT */
/*      GL_INT */
/*      GL_UNSIGNED_INT */
/*      GL_FLOAT */

/* PolygonMode */
# GL_POINT                          0x1B00
# GL_LINE                           0x1B01
# GL_FILL                           0x1B02

/* ReadBufferMode */
/*      GL_FRONT_LEFT */
/*      GL_FRONT_RIGHT */
/*      GL_BACK_LEFT */
/*      GL_BACK_RIGHT */
/*      GL_FRONT */
/*      GL_BACK */
/*      GL_LEFT */
/*      GL_RIGHT */
/*      GL_AUX0 */
/*      GL_AUX1 */
/*      GL_AUX2 */
/*      GL_AUX3 */

/* RenderingMode */
# GL_RENDER                         0x1C00
# GL_FEEDBACK                       0x1C01
# GL_SELECT                         0x1C02

/* ShadingModel */
# GL_FLAT                           0x1D00
# GL_SMOOTH                         0x1D01


/* StencilFunction */
/*      GL_NEVER */
/*      GL_LESS */
/*      GL_EQUAL */
/*      GL_LEQUAL */
/*      GL_GREATER */
/*      GL_NOTEQUAL */
/*      GL_GEQUAL */
/*      GL_ALWAYS */

/* StencilOp */
/*      GL_ZERO */
# GL_KEEP                           0x1E00
# GL_REPLACE                        0x1E01
# GL_INCR                           0x1E02
# GL_DECR                           0x1E03
/*      GL_INVERT */

/* StringName */
# GL_VENDOR                         0x1F00
# GL_RENDERER                       0x1F01
# GL_VERSION                        0x1F02
# GL_EXTENSIONS                     0x1F03

/* TextureCoordName */
# GL_S                              0x2000
# GL_T                              0x2001
# GL_R                              0x2002
# GL_Q                              0x2003

/* TexCoordPointerType */
/*      GL_SHORT */
/*      GL_INT */
/*      GL_FLOAT */
/*      GL_DOUBLE */

/* TextureEnvMode */
# GL_MODULATE                       0x2100
# GL_DECAL                          0x2101
/*      GL_BLEND */
/*      GL_REPLACE */

/* TextureEnvParameter */
# GL_TEXTURE_ENV_MODE               0x2200
# GL_TEXTURE_ENV_COLOR              0x2201

/* TextureEnvTarget */
# GL_TEXTURE_ENV                    0x2300

/* TextureGenMode */
# GL_EYE_LINEAR                     0x2400
# GL_OBJECT_LINEAR                  0x2401
# GL_SPHERE_MAP                     0x2402

/* TextureGenParameter */
# GL_TEXTURE_GEN_MODE               0x2500
# GL_OBJECT_PLANE                   0x2501
# GL_EYE_PLANE                      0x2502

/* TextureMagFilter */
# GL_NEAREST                        0x2600
# GL_LINEAR                         0x2601

/* TextureMinFilter */
/*      GL_NEAREST */
/*      GL_LINEAR */
# GL_NEAREST_MIPMAP_NEAREST         0x2700
# GL_LINEAR_MIPMAP_NEAREST          0x2701
# GL_NEAREST_MIPMAP_LINEAR          0x2702
# GL_LINEAR_MIPMAP_LINEAR           0x2703

/* TextureParameterName */
# GL_TEXTURE_MAG_FILTER             0x2800
# GL_TEXTURE_MIN_FILTER             0x2801
# GL_TEXTURE_WRAP_S                 0x2802
# GL_TEXTURE_WRAP_T                 0x2803
/*      GL_TEXTURE_BORDER_COLOR */
/*      GL_TEXTURE_PRIORITY */

/* TextureTarget */
/*      GL_TEXTURE_1D */
/*      GL_TEXTURE_2D */
/*      GL_PROXY_TEXTURE_1D */
/*      GL_PROXY_TEXTURE_2D */

/* TextureWrapMode */
# GL_CLAMP                          0x2900
# GL_REPEAT                         0x2901

/* VertexPointerType */
/*      GL_SHORT */
/*      GL_INT */
/*      GL_FLOAT */
/*      GL_DOUBLE */

/* ClientAttribMask */
# GL_CLIENT_PIXEL_STORE_BIT         0x00000001
# GL_CLIENT_VERTEX_ARRAY_BIT        0x00000002
# GL_CLIENT_ALL_ATTRIB_BITS         0xffffffff

/* polygon_offset */
# GL_POLYGON_OFFSET_FACTOR          0x8038
# GL_POLYGON_OFFSET_UNITS           0x2A00
# GL_POLYGON_OFFSET_POINT           0x2A01
# GL_POLYGON_OFFSET_LINE            0x2A02
# GL_POLYGON_OFFSET_FILL            0x8037

/* texture */
# GL_ALPHA4                         0x803B
# GL_ALPHA8                         0x803C
# GL_ALPHA12                        0x803D
# GL_ALPHA16                        0x803E
# GL_LUMINANCE4                     0x803F
# GL_LUMINANCE8                     0x8040
# GL_LUMINANCE12                    0x8041
# GL_LUMINANCE16                    0x8042
# GL_LUMINANCE4_ALPHA4              0x8043
# GL_LUMINANCE6_ALPHA2              0x8044
# GL_LUMINANCE8_ALPHA8              0x8045
# GL_LUMINANCE12_ALPHA4             0x8046
# GL_LUMINANCE12_ALPHA12            0x8047
# GL_LUMINANCE16_ALPHA16            0x8048
# GL_INTENSITY                      0x8049
# GL_INTENSITY4                     0x804A
# GL_INTENSITY8                     0x804B
# GL_INTENSITY12                    0x804C
# GL_INTENSITY16                    0x804D
# GL_R3_G3_B2                       0x2A10
# GL_RGB4                           0x804F
# GL_RGB5                           0x8050
# GL_RGB8                           0x8051
# GL_RGB10                          0x8052
# GL_RGB12                          0x8053
# GL_RGB16                          0x8054
# GL_RGBA2                          0x8055
# GL_RGBA4                          0x8056
# GL_RGB5_A1                        0x8057
# GL_RGBA8                          0x8058
# GL_RGB10_A2                       0x8059
# GL_RGBA12                         0x805A
# GL_RGBA16                         0x805B
# GL_TEXTURE_RED_SIZE               0x805C
# GL_TEXTURE_GREEN_SIZE             0x805D
# GL_TEXTURE_BLUE_SIZE              0x805E
# GL_TEXTURE_ALPHA_SIZE             0x805F
# GL_TEXTURE_LUMINANCE_SIZE         0x8060
# GL_TEXTURE_INTENSITY_SIZE         0x8061
# GL_PROXY_TEXTURE_1D               0x8063
# GL_PROXY_TEXTURE_2D               0x8064

/* texture_object */
# GL_TEXTURE_PRIORITY               0x8066
# GL_TEXTURE_RESIDENT               0x8067
# GL_TEXTURE_BINDING_1D             0x8068
# GL_TEXTURE_BINDING_2D             0x8069

/* vertex_array */
# GL_VERTEX_ARRAY                   0x8074
# GL_NORMAL_ARRAY                   0x8075
# GL_COLOR_ARRAY                    0x8076
# GL_INDEX_ARRAY                    0x8077
# GL_TEXTURE_COORD_ARRAY            0x8078
# GL_EDGE_FLAG_ARRAY                0x8079
# GL_VERTEX_ARRAY_SIZE              0x807A
# GL_VERTEX_ARRAY_TYPE              0x807B
# GL_VERTEX_ARRAY_STRIDE            0x807C
# GL_NORMAL_ARRAY_TYPE              0x807E
# GL_NORMAL_ARRAY_STRIDE            0x807F
# GL_COLOR_ARRAY_SIZE               0x8081
# GL_COLOR_ARRAY_TYPE               0x8082
# GL_COLOR_ARRAY_STRIDE             0x8083
# GL_INDEX_ARRAY_TYPE               0x8085
# GL_INDEX_ARRAY_STRIDE             0x8086
# GL_TEXTURE_COORD_ARRAY_SIZE       0x8088
# GL_TEXTURE_COORD_ARRAY_TYPE       0x8089
# GL_TEXTURE_COORD_ARRAY_STRIDE     0x808A
# GL_EDGE_FLAG_ARRAY_STRIDE         0x808C
# GL_VERTEX_ARRAY_POINTER           0x808E
# GL_NORMAL_ARRAY_POINTER           0x808F
# GL_COLOR_ARRAY_POINTER            0x8090
# GL_INDEX_ARRAY_POINTER            0x8091
# GL_TEXTURE_COORD_ARRAY_POINTER    0x8092
# GL_EDGE_FLAG_ARRAY_POINTER        0x8093
# GL_V2F                            0x2A20
# GL_V3F                            0x2A21
# GL_C4UB_V2F                       0x2A22
# GL_C4UB_V3F                       0x2A23
# GL_C3F_V3F                        0x2A24
# GL_N3F_V3F                        0x2A25
# GL_C4F_N3F_V3F                    0x2A26
# GL_T2F_V3F                        0x2A27
# GL_T4F_V4F                        0x2A28
# GL_T2F_C4UB_V3F                   0x2A29
# GL_T2F_C3F_V3F                    0x2A2A
# GL_T2F_N3F_V3F                    0x2A2B
# GL_T2F_C4F_N3F_V3F                0x2A2C
# GL_T4F_C4F_N3F_V4F                0x2A2D

/* Extensions */
# GL_EXT_vertex_array               1
# GL_EXT_bgra                       1
# GL_EXT_paletted_texture           1
# GL_WIN_swap_hint                  1
# GL_WIN_draw_range_elements        1
// # GL_WIN_phong_shading              1
// # GL_WIN_specular_fog               1

/* EXT_vertex_array */
# GL_VERTEX_ARRAY_EXT               0x8074
# GL_NORMAL_ARRAY_EXT               0x8075
# GL_COLOR_ARRAY_EXT                0x8076
# GL_INDEX_ARRAY_EXT                0x8077
# GL_TEXTURE_COORD_ARRAY_EXT        0x8078
# GL_EDGE_FLAG_ARRAY_EXT            0x8079
# GL_VERTEX_ARRAY_SIZE_EXT          0x807A
# GL_VERTEX_ARRAY_TYPE_EXT          0x807B
# GL_VERTEX_ARRAY_STRIDE_EXT        0x807C
# GL_VERTEX_ARRAY_COUNT_EXT         0x807D
# GL_NORMAL_ARRAY_TYPE_EXT          0x807E
# GL_NORMAL_ARRAY_STRIDE_EXT        0x807F
# GL_NORMAL_ARRAY_COUNT_EXT         0x8080
# GL_COLOR_ARRAY_SIZE_EXT           0x8081
# GL_COLOR_ARRAY_TYPE_EXT           0x8082
# GL_COLOR_ARRAY_STRIDE_EXT         0x8083
# GL_COLOR_ARRAY_COUNT_EXT          0x8084
# GL_INDEX_ARRAY_TYPE_EXT           0x8085
# GL_INDEX_ARRAY_STRIDE_EXT         0x8086
# GL_INDEX_ARRAY_COUNT_EXT          0x8087
# GL_TEXTURE_COORD_ARRAY_SIZE_EXT   0x8088
# GL_TEXTURE_COORD_ARRAY_TYPE_EXT   0x8089
# GL_TEXTURE_COORD_ARRAY_STRIDE_EXT 0x808A
# GL_TEXTURE_COORD_ARRAY_COUNT_EXT  0x808B
# GL_EDGE_FLAG_ARRAY_STRIDE_EXT     0x808C
# GL_EDGE_FLAG_ARRAY_COUNT_EXT      0x808D
# GL_VERTEX_ARRAY_POINTER_EXT       0x808E
# GL_NORMAL_ARRAY_POINTER_EXT       0x808F
# GL_COLOR_ARRAY_POINTER_EXT        0x8090
# GL_INDEX_ARRAY_POINTER_EXT        0x8091
# GL_TEXTURE_COORD_ARRAY_POINTER_EXT 0x8092
# GL_EDGE_FLAG_ARRAY_POINTER_EXT    0x8093
# GL_DOUBLE_EXT                     GL_DOUBLE

/* EXT_bgra */
# GL_BGR_EXT                        0x80E0
# GL_BGRA_EXT                       0x80E1

/* EXT_paletted_texture */

/* These must match the GL_COLOR_TABLE_*_SGI enumerants */
# GL_COLOR_TABLE_FORMAT_EXT         0x80D8
# GL_COLOR_TABLE_WIDTH_EXT          0x80D9
# GL_COLOR_TABLE_RED_SIZE_EXT       0x80DA
# GL_COLOR_TABLE_GREEN_SIZE_EXT     0x80DB
# GL_COLOR_TABLE_BLUE_SIZE_EXT      0x80DC
# GL_COLOR_TABLE_ALPHA_SIZE_EXT     0x80DD
# GL_COLOR_TABLE_LUMINANCE_SIZE_EXT 0x80DE
# GL_COLOR_TABLE_INTENSITY_SIZE_EXT 0x80DF

# GL_COLOR_INDEX1_EXT               0x80E2
# GL_COLOR_INDEX2_EXT               0x80E3
# GL_COLOR_INDEX4_EXT               0x80E4
# GL_COLOR_INDEX8_EXT               0x80E5
# GL_COLOR_INDEX12_EXT              0x80E6
# GL_COLOR_INDEX16_EXT              0x80E7

/* WIN_draw_range_elements */
# GL_MAX_ELEMENTS_VERTICES_WIN      0x80E8
# GL_MAX_ELEMENTS_INDICES_WIN       0x80E9

/* WIN_phong_shading */
# GL_PHONG_WIN                      0x80EA 
# GL_PHONG_HINT_WIN                 0x80EB 

/* WIN_specular_fog */
# GL_FOG_SPECULAR_TEXTURE_WIN       0x80EC

/* For compatibility with OpenGL v1.0 */
# GL_LOGIC_OP GL_INDEX_LOGIC_OP
# GL_TEXTURE_COMPONENTS GL_TEXTURE_INTERNAL_FORMAT

/*************************************************************/

WINGDIAPI void APIENTRY glAccum (GLenum op, GLfloat value);
WINGDIAPI void APIENTRY glAlphaFunc (GLenum func, GLclampf ref);
WINGDIAPI GLboolean APIENTRY glAreTexturesResident (GLsizei n, const GLuint *textures, GLboolean *residences);
WINGDIAPI void APIENTRY glArrayElement (GLint i);
WINGDIAPI void APIENTRY glBegin (GLenum mode);
WINGDIAPI void APIENTRY glBindTexture (GLenum target, GLuint texture);
WINGDIAPI void APIENTRY glBitmap (GLsizei width, GLsizei height, GLfloat xorig, GLfloat yorig, GLfloat xmove, GLfloat ymove, const GLubyte *bitmap);
WINGDIAPI void APIENTRY glBlendFunc (GLenum sfactor, GLenum dfactor);
WINGDIAPI void APIENTRY glCallList (GLuint list);
WINGDIAPI void APIENTRY glCallLists (GLsizei n, GLenum type, const GLvoid *lists);
WINGDIAPI void APIENTRY glClear (GLbitfield mask);
WINGDIAPI void APIENTRY glClearAccum (GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha);
WINGDIAPI void APIENTRY glClearColor (GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
WINGDIAPI void APIENTRY glClearDepth (GLclampd depth);
WINGDIAPI void APIENTRY glClearIndex (GLfloat c);
WINGDIAPI void APIENTRY glClearStencil (GLint s);
WINGDIAPI void APIENTRY glClipPlane (GLenum plane, const GLdouble *equation);
WINGDIAPI void APIENTRY glColor3b (GLbyte red, GLbyte green, GLbyte blue);
WINGDIAPI void APIENTRY glColor3bv (const GLbyte *v);
WINGDIAPI void APIENTRY glColor3d (GLdouble red, GLdouble green, GLdouble blue);
WINGDIAPI void APIENTRY glColor3dv (const GLdouble *v);
WINGDIAPI void APIENTRY glColor3f (GLfloat red, GLfloat green, GLfloat blue);
WINGDIAPI void APIENTRY glColor3fv (const GLfloat *v);
WINGDIAPI void APIENTRY glColor3i (GLint red, GLint green, GLint blue);
WINGDIAPI void APIENTRY glColor3iv (const GLint *v);
WINGDIAPI void APIENTRY glColor3s (GLshort red, GLshort green, GLshort blue);
WINGDIAPI void APIENTRY glColor3sv (const GLshort *v);
WINGDIAPI void APIENTRY glColor3ub (GLubyte red, GLubyte green, GLubyte blue);
WINGDIAPI void APIENTRY glColor3ubv (const GLubyte *v);
WINGDIAPI void APIENTRY glColor3ui (GLuint red, GLuint green, GLuint blue);
WINGDIAPI void APIENTRY glColor3uiv (const GLuint *v);
WINGDIAPI void APIENTRY glColor3us (GLushort red, GLushort green, GLushort blue);
WINGDIAPI void APIENTRY glColor3usv (const GLushort *v);
WINGDIAPI void APIENTRY glColor4b (GLbyte red, GLbyte green, GLbyte blue, GLbyte alpha);
WINGDIAPI void APIENTRY glColor4bv (const GLbyte *v);
WINGDIAPI void APIENTRY glColor4d (GLdouble red, GLdouble green, GLdouble blue, GLdouble alpha);
WINGDIAPI void APIENTRY glColor4dv (const GLdouble *v);
WINGDIAPI void APIENTRY glColor4f (GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha);
WINGDIAPI void APIENTRY glColor4fv (const GLfloat *v);
WINGDIAPI void APIENTRY glColor4i (GLint red, GLint green, GLint blue, GLint alpha);
WINGDIAPI void APIENTRY glColor4iv (const GLint *v);
WINGDIAPI void APIENTRY glColor4s (GLshort red, GLshort green, GLshort blue, GLshort alpha);
WINGDIAPI void APIENTRY glColor4sv (const GLshort *v);
WINGDIAPI void APIENTRY glColor4ub (GLubyte red, GLubyte green, GLubyte blue, GLubyte alpha);
WINGDIAPI void APIENTRY glColor4ubv (const GLubyte *v);
WINGDIAPI void APIENTRY glColor4ui (GLuint red, GLuint green, GLuint blue, GLuint alpha);
WINGDIAPI void APIENTRY glColor4uiv (const GLuint *v);
WINGDIAPI void APIENTRY glColor4us (GLushort red, GLushort green, GLushort blue, GLushort alpha);
WINGDIAPI void APIENTRY glColor4usv (const GLushort *v);
WINGDIAPI void APIENTRY glColorMask (GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha);
WINGDIAPI void APIENTRY glColorMaterial (GLenum face, GLenum mode);
WINGDIAPI void APIENTRY glColorPointer (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
WINGDIAPI void APIENTRY glCopyPixels (GLint x, GLint y, GLsizei width, GLsizei height, GLenum type);
WINGDIAPI void APIENTRY glCopyTexImage1D (GLenum target, GLint level, GLenum internalFormat, GLint x, GLint y, GLsizei width, GLint border);
WINGDIAPI void APIENTRY glCopyTexImage2D (GLenum target, GLint level, GLenum internalFormat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border);
WINGDIAPI void APIENTRY glCopyTexSubImage1D (GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width);
WINGDIAPI void APIENTRY glCopyTexSubImage2D (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height);
WINGDIAPI void APIENTRY glCullFace (GLenum mode);
WINGDIAPI void APIENTRY glDeleteLists (GLuint list, GLsizei range);
WINGDIAPI void APIENTRY glDeleteTextures (GLsizei n, const GLuint *textures);
WINGDIAPI void APIENTRY glDepthFunc (GLenum func);
WINGDIAPI void APIENTRY glDepthMask (GLboolean flag);
WINGDIAPI void APIENTRY glDepthRange (GLclampd zNear, GLclampd zFar);
WINGDIAPI void APIENTRY glDisable (GLenum cap);
WINGDIAPI void APIENTRY glDisableClientState (GLenum array);
WINGDIAPI void APIENTRY glDrawArrays (GLenum mode, GLint first, GLsizei count);
WINGDIAPI void APIENTRY glDrawBuffer (GLenum mode);
WINGDIAPI void APIENTRY glDrawElements (GLenum mode, GLsizei count, GLenum type, const GLvoid *indices);
WINGDIAPI void APIENTRY glDrawPixels (GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels);
WINGDIAPI void APIENTRY glEdgeFlag (GLboolean flag);
WINGDIAPI void APIENTRY glEdgeFlagPointer (GLsizei stride, const GLvoid *pointer);
WINGDIAPI void APIENTRY glEdgeFlagv (const GLboolean *flag);
WINGDIAPI void APIENTRY glEnable (GLenum cap);
WINGDIAPI void APIENTRY glEnableClientState (GLenum array);
WINGDIAPI void APIENTRY glEnd (void);
WINGDIAPI void APIENTRY glEndList (void);
WINGDIAPI void APIENTRY glEvalCoord1d (GLdouble u);
WINGDIAPI void APIENTRY glEvalCoord1dv (const GLdouble *u);
WINGDIAPI void APIENTRY glEvalCoord1f (GLfloat u);
WINGDIAPI void APIENTRY glEvalCoord1fv (const GLfloat *u);
WINGDIAPI void APIENTRY glEvalCoord2d (GLdouble u, GLdouble v);
WINGDIAPI void APIENTRY glEvalCoord2dv (const GLdouble *u);
WINGDIAPI void APIENTRY glEvalCoord2f (GLfloat u, GLfloat v);
WINGDIAPI void APIENTRY glEvalCoord2fv (const GLfloat *u);
WINGDIAPI void APIENTRY glEvalMesh1 (GLenum mode, GLint i1, GLint i2);
WINGDIAPI void APIENTRY glEvalMesh2 (GLenum mode, GLint i1, GLint i2, GLint j1, GLint j2);
WINGDIAPI void APIENTRY glEvalPoint1 (GLint i);
WINGDIAPI void APIENTRY glEvalPoint2 (GLint i, GLint j);
WINGDIAPI void APIENTRY glFeedbackBuffer (GLsizei size, GLenum type, GLfloat *buffer);
WINGDIAPI void APIENTRY glFinish (void);
WINGDIAPI void APIENTRY glFlush (void);
WINGDIAPI void APIENTRY glFogf (GLenum pname, GLfloat param);
WINGDIAPI void APIENTRY glFogfv (GLenum pname, const GLfloat *params);
WINGDIAPI void APIENTRY glFogi (GLenum pname, GLint param);
WINGDIAPI void APIENTRY glFogiv (GLenum pname, const GLint *params);
WINGDIAPI void APIENTRY glFrontFace (GLenum mode);
WINGDIAPI void APIENTRY glFrustum (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar);
WINGDIAPI GLuint APIENTRY glGenLists (GLsizei range);
WINGDIAPI void APIENTRY glGenTextures (GLsizei n, GLuint *textures);
WINGDIAPI void APIENTRY glGetBooleanv (GLenum pname, GLboolean *params);
WINGDIAPI void APIENTRY glGetClipPlane (GLenum plane, GLdouble *equation);
WINGDIAPI void APIENTRY glGetDoublev (GLenum pname, GLdouble *params);
WINGDIAPI GLenum APIENTRY glGetError (void);
WINGDIAPI void APIENTRY glGetFloatv (GLenum pname, GLfloat *params);
WINGDIAPI void APIENTRY glGetIntegerv (GLenum pname, GLint *params);
WINGDIAPI void APIENTRY glGetLightfv (GLenum light, GLenum pname, GLfloat *params);
WINGDIAPI void APIENTRY glGetLightiv (GLenum light, GLenum pname, GLint *params);
WINGDIAPI void APIENTRY glGetMapdv (GLenum target, GLenum query, GLdouble *v);
WINGDIAPI void APIENTRY glGetMapfv (GLenum target, GLenum query, GLfloat *v);
WINGDIAPI void APIENTRY glGetMapiv (GLenum target, GLenum query, GLint *v);
WINGDIAPI void APIENTRY glGetMaterialfv (GLenum face, GLenum pname, GLfloat *params);
WINGDIAPI void APIENTRY glGetMaterialiv (GLenum face, GLenum pname, GLint *params);
WINGDIAPI void APIENTRY glGetPixelMapfv (GLenum map, GLfloat *values);
WINGDIAPI void APIENTRY glGetPixelMapuiv (GLenum map, GLuint *values);
WINGDIAPI void APIENTRY glGetPixelMapusv (GLenum map, GLushort *values);
WINGDIAPI void APIENTRY glGetPointerv (GLenum pname, GLvoid* *params);
WINGDIAPI void APIENTRY glGetPolygonStipple (GLubyte *mask);
WINGDIAPI const GLubyte * APIENTRY glGetString (GLenum name);
WINGDIAPI void APIENTRY glGetTexEnvfv (GLenum target, GLenum pname, GLfloat *params);
WINGDIAPI void APIENTRY glGetTexEnviv (GLenum target, GLenum pname, GLint *params);
WINGDIAPI void APIENTRY glGetTexGendv (GLenum coord, GLenum pname, GLdouble *params);
WINGDIAPI void APIENTRY glGetTexGenfv (GLenum coord, GLenum pname, GLfloat *params);
WINGDIAPI void APIENTRY glGetTexGeniv (GLenum coord, GLenum pname, GLint *params);
WINGDIAPI void APIENTRY glGetTexImage (GLenum target, GLint level, GLenum format, GLenum type, GLvoid *pixels);
WINGDIAPI void APIENTRY glGetTexLevelParameterfv (GLenum target, GLint level, GLenum pname, GLfloat *params);
WINGDIAPI void APIENTRY glGetTexLevelParameteriv (GLenum target, GLint level, GLenum pname, GLint *params);
WINGDIAPI void APIENTRY glGetTexParameterfv (GLenum target, GLenum pname, GLfloat *params);
WINGDIAPI void APIENTRY glGetTexParameteriv (GLenum target, GLenum pname, GLint *params);
WINGDIAPI void APIENTRY glHint (GLenum target, GLenum mode);
WINGDIAPI void APIENTRY glIndexMask (GLuint mask);
WINGDIAPI void APIENTRY glIndexPointer (GLenum type, GLsizei stride, const GLvoid *pointer);
WINGDIAPI void APIENTRY glIndexd (GLdouble c);
WINGDIAPI void APIENTRY glIndexdv (const GLdouble *c);
WINGDIAPI void APIENTRY glIndexf (GLfloat c);
WINGDIAPI void APIENTRY glIndexfv (const GLfloat *c);
WINGDIAPI void APIENTRY glIndexi (GLint c);
WINGDIAPI void APIENTRY glIndexiv (const GLint *c);
WINGDIAPI void APIENTRY glIndexs (GLshort c);
WINGDIAPI void APIENTRY glIndexsv (const GLshort *c);
WINGDIAPI void APIENTRY glIndexub (GLubyte c);
WINGDIAPI void APIENTRY glIndexubv (const GLubyte *c);
WINGDIAPI void APIENTRY glInitNames (void);
WINGDIAPI void APIENTRY glInterleavedArrays (GLenum format, GLsizei stride, const GLvoid *pointer);
WINGDIAPI GLboolean APIENTRY glIsEnabled (GLenum cap);
WINGDIAPI GLboolean APIENTRY glIsList (GLuint list);
WINGDIAPI GLboolean APIENTRY glIsTexture (GLuint texture);
WINGDIAPI void APIENTRY glLightModelf (GLenum pname, GLfloat param);
WINGDIAPI void APIENTRY glLightModelfv (GLenum pname, const GLfloat *params);
WINGDIAPI void APIENTRY glLightModeli (GLenum pname, GLint param);
WINGDIAPI void APIENTRY glLightModeliv (GLenum pname, const GLint *params);
WINGDIAPI void APIENTRY glLightf (GLenum light, GLenum pname, GLfloat param);
WINGDIAPI void APIENTRY glLightfv (GLenum light, GLenum pname, const GLfloat *params);
WINGDIAPI void APIENTRY glLighti (GLenum light, GLenum pname, GLint param);
WINGDIAPI void APIENTRY glLightiv (GLenum light, GLenum pname, const GLint *params);
WINGDIAPI void APIENTRY glLineStipple (GLint factor, GLushort pattern);
WINGDIAPI void APIENTRY glLineWidth (GLfloat width);
WINGDIAPI void APIENTRY glListBase (GLuint base);
WINGDIAPI void APIENTRY glLoadIdentity (void);
WINGDIAPI void APIENTRY glLoadMatrixd (const GLdouble *m);
WINGDIAPI void APIENTRY glLoadMatrixf (const GLfloat *m);
WINGDIAPI void APIENTRY glLoadName (GLuint name);
WINGDIAPI void APIENTRY glLogicOp (GLenum opcode);
WINGDIAPI void APIENTRY glMap1d (GLenum target, GLdouble u1, GLdouble u2, GLint stride, GLint order, const GLdouble *points);
WINGDIAPI void APIENTRY glMap1f (GLenum target, GLfloat u1, GLfloat u2, GLint stride, GLint order, const GLfloat *points);
WINGDIAPI void APIENTRY glMap2d (GLenum target, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, const GLdouble *points);
WINGDIAPI void APIENTRY glMap2f (GLenum target, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, const GLfloat *points);
WINGDIAPI void APIENTRY glMapGrid1d (GLint un, GLdouble u1, GLdouble u2);
WINGDIAPI void APIENTRY glMapGrid1f (GLint un, GLfloat u1, GLfloat u2);
WINGDIAPI void APIENTRY glMapGrid2d (GLint un, GLdouble u1, GLdouble u2, GLint vn, GLdouble v1, GLdouble v2);
WINGDIAPI void APIENTRY glMapGrid2f (GLint un, GLfloat u1, GLfloat u2, GLint vn, GLfloat v1, GLfloat v2);
WINGDIAPI void APIENTRY glMaterialf (GLenum face, GLenum pname, GLfloat param);
WINGDIAPI void APIENTRY glMaterialfv (GLenum face, GLenum pname, const GLfloat *params);
WINGDIAPI void APIENTRY glMateriali (GLenum face, GLenum pname, GLint param);
WINGDIAPI void APIENTRY glMaterialiv (GLenum face, GLenum pname, const GLint *params);
WINGDIAPI void APIENTRY glMatrixMode (GLenum mode);
WINGDIAPI void APIENTRY glMultMatrixd (const GLdouble *m);
WINGDIAPI void APIENTRY glMultMatrixf (const GLfloat *m);
WINGDIAPI void APIENTRY glNewList (GLuint list, GLenum mode);
WINGDIAPI void APIENTRY glNormal3b (GLbyte nx, GLbyte ny, GLbyte nz);
WINGDIAPI void APIENTRY glNormal3bv (const GLbyte *v);
WINGDIAPI void APIENTRY glNormal3d (GLdouble nx, GLdouble ny, GLdouble nz);
WINGDIAPI void APIENTRY glNormal3dv (const GLdouble *v);
WINGDIAPI void APIENTRY glNormal3f (GLfloat nx, GLfloat ny, GLfloat nz);
WINGDIAPI void APIENTRY glNormal3fv (const GLfloat *v);
WINGDIAPI void APIENTRY glNormal3i (GLint nx, GLint ny, GLint nz);
WINGDIAPI void APIENTRY glNormal3iv (const GLint *v);
WINGDIAPI void APIENTRY glNormal3s (GLshort nx, GLshort ny, GLshort nz);
WINGDIAPI void APIENTRY glNormal3sv (const GLshort *v);
WINGDIAPI void APIENTRY glNormalPointer (GLenum type, GLsizei stride, const GLvoid *pointer);
WINGDIAPI void APIENTRY glOrtho (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar);
WINGDIAPI void APIENTRY glPassThrough (GLfloat token);
WINGDIAPI void APIENTRY glPixelMapfv (GLenum map, GLsizei mapsize, const GLfloat *values);
WINGDIAPI void APIENTRY glPixelMapuiv (GLenum map, GLsizei mapsize, const GLuint *values);
WINGDIAPI void APIENTRY glPixelMapusv (GLenum map, GLsizei mapsize, const GLushort *values);
WINGDIAPI void APIENTRY glPixelStoref (GLenum pname, GLfloat param);
WINGDIAPI void APIENTRY glPixelStorei (GLenum pname, GLint param);
WINGDIAPI void APIENTRY glPixelTransferf (GLenum pname, GLfloat param);
WINGDIAPI void APIENTRY glPixelTransferi (GLenum pname, GLint param);
WINGDIAPI void APIENTRY glPixelZoom (GLfloat xfactor, GLfloat yfactor);
WINGDIAPI void APIENTRY glPointSize (GLfloat size);
WINGDIAPI void APIENTRY glPolygonMode (GLenum face, GLenum mode);
WINGDIAPI void APIENTRY glPolygonOffset (GLfloat factor, GLfloat units);
WINGDIAPI void APIENTRY glPolygonStipple (const GLubyte *mask);
WINGDIAPI void APIENTRY glPopAttrib (void);
WINGDIAPI void APIENTRY glPopClientAttrib (void);
WINGDIAPI void APIENTRY glPopMatrix (void);
WINGDIAPI void APIENTRY glPopName (void);
WINGDIAPI void APIENTRY glPrioritizeTextures (GLsizei n, const GLuint *textures, const GLclampf *priorities);
WINGDIAPI void APIENTRY glPushAttrib (GLbitfield mask);
WINGDIAPI void APIENTRY glPushClientAttrib (GLbitfield mask);
WINGDIAPI void APIENTRY glPushMatrix (void);
WINGDIAPI void APIENTRY glPushName (GLuint name);
WINGDIAPI void APIENTRY glRasterPos2d (GLdouble x, GLdouble y);
WINGDIAPI void APIENTRY glRasterPos2dv (const GLdouble *v);
WINGDIAPI void APIENTRY glRasterPos2f (GLfloat x, GLfloat y);
WINGDIAPI void APIENTRY glRasterPos2fv (const GLfloat *v);
WINGDIAPI void APIENTRY glRasterPos2i (GLint x, GLint y);
WINGDIAPI void APIENTRY glRasterPos2iv (const GLint *v);
WINGDIAPI void APIENTRY glRasterPos2s (GLshort x, GLshort y);
WINGDIAPI void APIENTRY glRasterPos2sv (const GLshort *v);
WINGDIAPI void APIENTRY glRasterPos3d (GLdouble x, GLdouble y, GLdouble z);
WINGDIAPI void APIENTRY glRasterPos3dv (const GLdouble *v);
WINGDIAPI void APIENTRY glRasterPos3f (GLfloat x, GLfloat y, GLfloat z);
WINGDIAPI void APIENTRY glRasterPos3fv (const GLfloat *v);
WINGDIAPI void APIENTRY glRasterPos3i (GLint x, GLint y, GLint z);
WINGDIAPI void APIENTRY glRasterPos3iv (const GLint *v);
WINGDIAPI void APIENTRY glRasterPos3s (GLshort x, GLshort y, GLshort z);
WINGDIAPI void APIENTRY glRasterPos3sv (const GLshort *v);
WINGDIAPI void APIENTRY glRasterPos4d (GLdouble x, GLdouble y, GLdouble z, GLdouble w);
WINGDIAPI void APIENTRY glRasterPos4dv (const GLdouble *v);
WINGDIAPI void APIENTRY glRasterPos4f (GLfloat x, GLfloat y, GLfloat z, GLfloat w);
WINGDIAPI void APIENTRY glRasterPos4fv (const GLfloat *v);
WINGDIAPI void APIENTRY glRasterPos4i (GLint x, GLint y, GLint z, GLint w);
WINGDIAPI void APIENTRY glRasterPos4iv (const GLint *v);
WINGDIAPI void APIENTRY glRasterPos4s (GLshort x, GLshort y, GLshort z, GLshort w);
WINGDIAPI void APIENTRY glRasterPos4sv (const GLshort *v);
WINGDIAPI void APIENTRY glReadBuffer (GLenum mode);
WINGDIAPI void APIENTRY glReadPixels (GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *pixels);
WINGDIAPI void APIENTRY glRectd (GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2);
WINGDIAPI void APIENTRY glRectdv (const GLdouble *v1, const GLdouble *v2);
WINGDIAPI void APIENTRY glRectf (GLfloat x1, GLfloat y1, GLfloat x2, GLfloat y2);
WINGDIAPI void APIENTRY glRectfv (const GLfloat *v1, const GLfloat *v2);
WINGDIAPI void APIENTRY glRecti (GLint x1, GLint y1, GLint x2, GLint y2);
WINGDIAPI void APIENTRY glRectiv (const GLint *v1, const GLint *v2);
WINGDIAPI void APIENTRY glRects (GLshort x1, GLshort y1, GLshort x2, GLshort y2);
WINGDIAPI void APIENTRY glRectsv (const GLshort *v1, const GLshort *v2);
WINGDIAPI GLint APIENTRY glRenderMode (GLenum mode);
WINGDIAPI void APIENTRY glRotated (GLdouble angle, GLdouble x, GLdouble y, GLdouble z);
WINGDIAPI void APIENTRY glRotatef (GLfloat angle, GLfloat x, GLfloat y, GLfloat z);
WINGDIAPI void APIENTRY glScaled (GLdouble x, GLdouble y, GLdouble z);
WINGDIAPI void APIENTRY glScalef (GLfloat x, GLfloat y, GLfloat z);
WINGDIAPI void APIENTRY glScissor (GLint x, GLint y, GLsizei width, GLsizei height);
WINGDIAPI void APIENTRY glSelectBuffer (GLsizei size, GLuint *buffer);
WINGDIAPI void APIENTRY glShadeModel (GLenum mode);
WINGDIAPI void APIENTRY glStencilFunc (GLenum func, GLint ref, GLuint mask);
WINGDIAPI void APIENTRY glStencilMask (GLuint mask);
WINGDIAPI void APIENTRY glStencilOp (GLenum fail, GLenum zfail, GLenum zpass);
WINGDIAPI void APIENTRY glTexCoord1d (GLdouble s);
WINGDIAPI void APIENTRY glTexCoord1dv (const GLdouble *v);
WINGDIAPI void APIENTRY glTexCoord1f (GLfloat s);
WINGDIAPI void APIENTRY glTexCoord1fv (const GLfloat *v);
WINGDIAPI void APIENTRY glTexCoord1i (GLint s);
WINGDIAPI void APIENTRY glTexCoord1iv (const GLint *v);
WINGDIAPI void APIENTRY glTexCoord1s (GLshort s);
WINGDIAPI void APIENTRY glTexCoord1sv (const GLshort *v);
WINGDIAPI void APIENTRY glTexCoord2d (GLdouble s, GLdouble t);
WINGDIAPI void APIENTRY glTexCoord2dv (const GLdouble *v);
WINGDIAPI void APIENTRY glTexCoord2f (GLfloat s, GLfloat t);
WINGDIAPI void APIENTRY glTexCoord2fv (const GLfloat *v);
WINGDIAPI void APIENTRY glTexCoord2i (GLint s, GLint t);
WINGDIAPI void APIENTRY glTexCoord2iv (const GLint *v);
WINGDIAPI void APIENTRY glTexCoord2s (GLshort s, GLshort t);
WINGDIAPI void APIENTRY glTexCoord2sv (const GLshort *v);
WINGDIAPI void APIENTRY glTexCoord3d (GLdouble s, GLdouble t, GLdouble r);
WINGDIAPI void APIENTRY glTexCoord3dv (const GLdouble *v);
WINGDIAPI void APIENTRY glTexCoord3f (GLfloat s, GLfloat t, GLfloat r);
WINGDIAPI void APIENTRY glTexCoord3fv (const GLfloat *v);
WINGDIAPI void APIENTRY glTexCoord3i (GLint s, GLint t, GLint r);
WINGDIAPI void APIENTRY glTexCoord3iv (const GLint *v);
WINGDIAPI void APIENTRY glTexCoord3s (GLshort s, GLshort t, GLshort r);
WINGDIAPI void APIENTRY glTexCoord3sv (const GLshort *v);
WINGDIAPI void APIENTRY glTexCoord4d (GLdouble s, GLdouble t, GLdouble r, GLdouble q);
WINGDIAPI void APIENTRY glTexCoord4dv (const GLdouble *v);
WINGDIAPI void APIENTRY glTexCoord4f (GLfloat s, GLfloat t, GLfloat r, GLfloat q);
WINGDIAPI void APIENTRY glTexCoord4fv (const GLfloat *v);
WINGDIAPI void APIENTRY glTexCoord4i (GLint s, GLint t, GLint r, GLint q);
WINGDIAPI void APIENTRY glTexCoord4iv (const GLint *v);
WINGDIAPI void APIENTRY glTexCoord4s (GLshort s, GLshort t, GLshort r, GLshort q);
WINGDIAPI void APIENTRY glTexCoord4sv (const GLshort *v);
WINGDIAPI void APIENTRY glTexCoordPointer (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
WINGDIAPI void APIENTRY glTexEnvf (GLenum target, GLenum pname, GLfloat param);
WINGDIAPI void APIENTRY glTexEnvfv (GLenum target, GLenum pname, const GLfloat *params);
WINGDIAPI void APIENTRY glTexEnvi (GLenum target, GLenum pname, GLint param);
WINGDIAPI void APIENTRY glTexEnviv (GLenum target, GLenum pname, const GLint *params);
WINGDIAPI void APIENTRY glTexGend (GLenum coord, GLenum pname, GLdouble param);
WINGDIAPI void APIENTRY glTexGendv (GLenum coord, GLenum pname, const GLdouble *params);
WINGDIAPI void APIENTRY glTexGenf (GLenum coord, GLenum pname, GLfloat param);
WINGDIAPI void APIENTRY glTexGenfv (GLenum coord, GLenum pname, const GLfloat *params);
WINGDIAPI void APIENTRY glTexGeni (GLenum coord, GLenum pname, GLint param);
WINGDIAPI void APIENTRY glTexGeniv (GLenum coord, GLenum pname, const GLint *params);
WINGDIAPI void APIENTRY glTexImage1D (GLenum target, GLint level, GLint internalformat, GLsizei width, GLint border, GLenum format, GLenum type, const GLvoid *pixels);
WINGDIAPI void APIENTRY glTexImage2D (GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid *pixels);
WINGDIAPI void APIENTRY glTexParameterf (GLenum target, GLenum pname, GLfloat param);
WINGDIAPI void APIENTRY glTexParameterfv (GLenum target, GLenum pname, const GLfloat *params);
WINGDIAPI void APIENTRY glTexParameteri (GLenum target, GLenum pname, GLint param);
WINGDIAPI void APIENTRY glTexParameteriv (GLenum target, GLenum pname, const GLint *params);
WINGDIAPI void APIENTRY glTexSubImage1D (GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, const GLvoid *pixels);
WINGDIAPI void APIENTRY glTexSubImage2D (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels);
WINGDIAPI void APIENTRY glTranslated (GLdouble x, GLdouble y, GLdouble z);
WINGDIAPI void APIENTRY glTranslatef (GLfloat x, GLfloat y, GLfloat z);
WINGDIAPI void APIENTRY glVertex2d (GLdouble x, GLdouble y);
WINGDIAPI void APIENTRY glVertex2dv (const GLdouble *v);
WINGDIAPI void APIENTRY glVertex2f (GLfloat x, GLfloat y);
WINGDIAPI void APIENTRY glVertex2fv (const GLfloat *v);
WINGDIAPI void APIENTRY glVertex2i (GLint x, GLint y);
WINGDIAPI void APIENTRY glVertex2iv (const GLint *v);
WINGDIAPI void APIENTRY glVertex2s (GLshort x, GLshort y);
WINGDIAPI void APIENTRY glVertex2sv (const GLshort *v);
WINGDIAPI void APIENTRY glVertex3d (GLdouble x, GLdouble y, GLdouble z);
WINGDIAPI void APIENTRY glVertex3dv (const GLdouble *v);
WINGDIAPI void APIENTRY glVertex3f (GLfloat x, GLfloat y, GLfloat z);
WINGDIAPI void APIENTRY glVertex3fv (const GLfloat *v);
WINGDIAPI void APIENTRY glVertex3i (GLint x, GLint y, GLint z);
WINGDIAPI void APIENTRY glVertex3iv (const GLint *v);
WINGDIAPI void APIENTRY glVertex3s (GLshort x, GLshort y, GLshort z);
WINGDIAPI void APIENTRY glVertex3sv (const GLshort *v);
WINGDIAPI void APIENTRY glVertex4d (GLdouble x, GLdouble y, GLdouble z, GLdouble w);
WINGDIAPI void APIENTRY glVertex4dv (const GLdouble *v);
WINGDIAPI void APIENTRY glVertex4f (GLfloat x, GLfloat y, GLfloat z, GLfloat w);
WINGDIAPI void APIENTRY glVertex4fv (const GLfloat *v);
WINGDIAPI void APIENTRY glVertex4i (GLint x, GLint y, GLint z, GLint w);
WINGDIAPI void APIENTRY glVertex4iv (const GLint *v);
WINGDIAPI void APIENTRY glVertex4s (GLshort x, GLshort y, GLshort z, GLshort w);
WINGDIAPI void APIENTRY glVertex4sv (const GLshort *v);
WINGDIAPI void APIENTRY glVertexPointer (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
WINGDIAPI void APIENTRY glViewport (GLint x, GLint y, GLsizei width, GLsizei height);

/* EXT_vertex_array */
Ͷ void (APIENTRY * PFNGLARRAYELEMENTEXTPROC) (GLint i);
Ͷ void (APIENTRY * PFNGLDRAWARRAYSEXTPROC) (GLenum mode, GLint first, GLsizei count);
Ͷ void (APIENTRY * PFNGLVERTEXPOINTEREXTPROC) (GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
Ͷ void (APIENTRY * PFNGLNORMALPOINTEREXTPROC) (GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
Ͷ void (APIENTRY * PFNGLCOLORPOINTEREXTPROC) (GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
Ͷ void (APIENTRY * PFNGLINDEXPOINTEREXTPROC) (GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
Ͷ void (APIENTRY * PFNGLTEXCOORDPOINTEREXTPROC) (GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
Ͷ void (APIENTRY * PFNGLEDGEFLAGPOINTEREXTPROC) (GLsizei stride, GLsizei count, const GLboolean *pointer);
Ͷ void (APIENTRY * PFNGLGETPOINTERVEXTPROC) (GLenum pname, GLvoid* *params);
Ͷ void (APIENTRY * PFNGLARRAYELEMENTARRAYEXTPROC)(GLenum mode, GLsizei count, const GLvoid* pi);

/* WIN_draw_range_elements */
Ͷ void (APIENTRY * PFNGLDRAWRANGEELEMENTSWINPROC) (GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const GLvoid *indices);

/* WIN_swap_hint */
Ͷ void (APIENTRY * PFNGLADDSWAPHINTRECTWINPROC)  (GLint x, GLint y, GLsizei width, GLsizei height);

/* EXT_paletted_texture */
Ͷ void (APIENTRY * PFNGLCOLORTABLEEXTPROC)
    (GLenum target, GLenum internalFormat, GLsizei width, GLenum format,
     GLenum type, const GLvoid *data);
Ͷ void (APIENTRY * PFNGLCOLORSUBTABLEEXTPROC)
    (GLenum target, GLsizei start, GLsizei count, GLenum format,
     GLenum type, const GLvoid *data);
Ͷ void (APIENTRY * PFNGLGETCOLORTABLEEXTPROC)
    (GLenum target, GLenum format, GLenum type, GLvoid *data);
Ͷ void (APIENTRY * PFNGLGETCOLORTABLEPARAMETERIVEXTPROC)
    (GLenum target, GLenum pname, GLint *params);
Ͷ void (APIENTRY * PFNGLGETCOLORTABLEPARAMETERFVEXTPROC)
    (GLenum target, GLenum pname, GLfloat *params);

#ifdef __cplusplus
}
#endif

#endif /* __GL_H__ */
