/***
*io.h - declarations ѭ low-level file handling and I/O functions
*
*       Copyright (c) 1985-1997, Microsoft Corporation. All rights reserved.
*
*Purpose:
*       This file contains the function declarations ѭ the low-level
*       file handling and I/O functions.
*
*       [Public]
*
****/

#     _MSC_VER > 1000
#ָ once
#

#δ _INC_IO
# _INC_IO

#     !Ѷ(_WIN32) && !defined(_MAC)
# ERROR: Only Mac or Win32 targets supported!
#


#Ѷ  _MSC_VER
/*
 * Currently, all MS C compilers ѭ Win32 platforms ֵ to 8 byte
 * alignment.
 */
#ָ pack(push,8)
#  /* _MSC_VER */

#δ _POSIX_

#Ѷ  __cplusplus
ⲿ "C" {
#



/* Define _CRTIMP */

#δ _CRTIMP
#Ѷ  _DLL
# _CRTIMP __declspec(dllimport)
#   /* ndef _DLL */
# _CRTIMP
#  /* _DLL */
#  /* _CRTIMP */


/* Define ϰ ѭ non-Microsoft compilers */

#     ( !Ѷ(_MSC_VER) && !defined(ϰ) )
# ϰ
#

/* Define _CRTAPI1 (ѭ compatibility with the NT SDK) */

#δ _CRTAPI1
#	_MSC_VER >= 800 && _M_IX86 >= 300
# _CRTAPI1 ϰ
#
# _CRTAPI1
#
#

#δ _MAC
#δ _WCHAR_T_DEFINED
Ͷ ޷  wchar_t;
# _WCHAR_T_DEFINED
#
#  /* ndef _MAC */

#δ _TIME_T_DEFINED
Ͷ long time_t;            /* time value */
# _TIME_T_DEFINED         /* avoid multiple def's of time_t */
#

#δ _FSIZE_T_DEFINED
Ͷ ޷ long _fsize_t; /* Could be 64 bits ѭ Win32 */
# _FSIZE_T_DEFINED
#

#δ _MAC

#δ _FINDDATA_T_DEFINED

ṹ _finddata_t {
    ޷    attrib;
    time_t      time_create;    /* -1 ѭ FAT file systems */
    time_t      time_access;    /* -1 ѭ FAT file systems */
    time_t      time_write;
    _fsize_t    size;
    ַ        name[260];
};

#     _INTEGRAL_MAX_BITS >= 64
ṹ _finddatai64_t {
    ޷    attrib;
    time_t      time_create;    /* -1 ѭ FAT file systems */
    time_t      time_access;    /* -1 ѭ FAT file systems */
    time_t      time_write;
         size;
    ַ        name[260];
};
#

# _FINDDATA_T_DEFINED
#

#δ _WFINDDATA_T_DEFINED

ṹ _wfinddata_t {
    ޷    attrib;
    time_t      time_create;    /* -1 ѭ FAT file systems */
    time_t      time_access;    /* -1 ѭ FAT file systems */
    time_t      time_write;
    _fsize_t    size;
    wchar_t     name[260];
};

#     _INTEGRAL_MAX_BITS >= 64
ṹ _wfinddatai64_t {
    ޷    attrib;
    time_t      time_create;    /* -1 ѭ FAT file systems */
    time_t      time_access;    /* -1 ѭ FAT file systems */
    time_t      time_write;
         size;
    wchar_t     name[260];
};
#

# _WFINDDATA_T_DEFINED
#

/* File attribute constants ѭ _findfirst() */

# _A_NORMAL       0x00    /* Normal file - No read/write restrictions */
# _A_RDONLY       0x01    /* Read only file */
# _A_HIDDEN       0x02    /* Hidden file */
# _A_SYSTEM       0x04    /* System file */
# _A_SUBDIR       0x10    /* Subdirectory */
# _A_ARCH         0x20    /* Archive file */

#  /* ndef _MAC */

/* function prototypes */

_CRTIMP  ϰ _access(ֻ ַ *, );
_CRTIMP  ϰ _chmod(ֻ ַ *, );
_CRTIMP  ϰ _chsize(, long);
_CRTIMP  ϰ _close();
_CRTIMP  ϰ _commit();
_CRTIMP  ϰ _creat(ֻ ַ *, );
_CRTIMP  ϰ _dup();
_CRTIMP  ϰ _dup2(, );
_CRTIMP  ϰ _eof();
_CRTIMP long ϰ _filelength();
#δ _MAC
_CRTIMP long ϰ _findfirst(ֻ ַ *, ṹ _finddata_t *);
_CRTIMP  ϰ _findnext(long, ṹ _finddata_t *);
_CRTIMP  ϰ _findclose(long);
#  /* ndef _MAC */
_CRTIMP  ϰ _isatty();
_CRTIMP  ϰ _locking(, , long);
_CRTIMP long ϰ _lseek(, long, );
_CRTIMP ַ * ϰ _mktemp(ַ *);
_CRTIMP  ϰ _open(ֻ ַ *, , ...);
#δ _MAC
_CRTIMP  ϰ _pipe( *, ޷ , );
#  /* ndef _MAC */
_CRTIMP  ϰ _read(,  *, ޷ );
_CRTIMP  ϰ remove(ֻ ַ *);
_CRTIMP  ϰ rename(ֻ ַ *, ֻ ַ *);
_CRTIMP  ϰ _setmode(, );
_CRTIMP  ϰ _sopen(ֻ ַ *, , , ...);
_CRTIMP long ϰ _tell();
_CRTIMP  ϰ _umask();
_CRTIMP  ϰ _unlink(ֻ ַ *);
_CRTIMP  ϰ _write(, ֻ  *, ޷ );

#     _INTEGRAL_MAX_BITS >= 64
_CRTIMP  ϰ _filelengthi64();
_CRTIMP long ϰ _findfirsti64(ֻ ַ *, ṹ _finddatai64_t *);
_CRTIMP  ϰ _findnexti64(long, ṹ _finddatai64_t *);
_CRTIMP  ϰ _lseeki64(, , );
_CRTIMP  ϰ _telli64();
#

#δ _MAC
#δ _WIO_DEFINED

/* wide function prototypes, also declared in wchar.h  */

_CRTIMP  ϰ _waccess(ֻ wchar_t *, );
_CRTIMP  ϰ _wchmod(ֻ wchar_t *, );
_CRTIMP  ϰ _wcreat(ֻ wchar_t *, );
_CRTIMP long ϰ _wfindfirst(ֻ wchar_t *, ṹ _wfinddata_t *);
_CRTIMP  ϰ _wfindnext(long, ṹ _wfinddata_t *);
_CRTIMP  ϰ _wunlink(ֻ wchar_t *);
_CRTIMP  ϰ _wrename(ֻ wchar_t *, ֻ wchar_t *);
_CRTIMP  ϰ _wopen(ֻ wchar_t *, , ...);
_CRTIMP  ϰ _wsopen(ֻ wchar_t *, , , ...);
_CRTIMP wchar_t * ϰ _wmktemp(wchar_t *);

#     _INTEGRAL_MAX_BITS >= 64
_CRTIMP long ϰ _wfindfirsti64(ֻ wchar_t *, ṹ _wfinddatai64_t *);
_CRTIMP  ϰ _wfindnexti64(long, ṹ _wfinddatai64_t *);
#

# _WIO_DEFINED
#
#  /* ndef _MAC */


_CRTIMP long ϰ _get_osfhandle();
_CRTIMP  ϰ _open_osfhandle(long, );

#     !__STDC__

/* Non-ANSI names ѭ compatibility */

_CRTIMP  ϰ access(ֻ ַ *, );
_CRTIMP  ϰ chmod(ֻ ַ *, );
_CRTIMP  ϰ chsize(, long);
_CRTIMP  ϰ close();
_CRTIMP  ϰ creat(ֻ ַ *, );
_CRTIMP  ϰ dup();
_CRTIMP  ϰ dup2(, );
_CRTIMP  ϰ eof();
_CRTIMP long ϰ filelength();
_CRTIMP  ϰ isatty();
_CRTIMP  ϰ locking(, , long);
_CRTIMP long ϰ lseek(, long, );
_CRTIMP ַ * ϰ mktemp(ַ *);
_CRTIMP  ϰ open(ֻ ַ *, , ...);
_CRTIMP  ϰ read(,  *, ޷ );
_CRTIMP  ϰ setmode(, );
_CRTIMP  ϰ sopen(ֻ ַ *, , , ...);
_CRTIMP long ϰ tell();
_CRTIMP  ϰ umask();
_CRTIMP  ϰ unlink(ֻ ַ *);
_CRTIMP  ϰ write(, ֻ  *, ޷ );

#  /* __STDC__ */

#Ѷ  __cplusplus
}
#

#  /* _POSIX_ */

#Ѷ  _MSC_VER
#ָ pack(pop)
#  /* _MSC_VER */

#  /* _INC_IO */
