/***
*iomanip.h - definitions/declarations ѭ iostream's parameterized manipulators
*
*       Copyright (c) 1991-1997, Microsoft Corporation.  All rights reserved.
*
*Purpose:
*       This file defines the classes, values, macros, and functions
*       used by the iostream classes' paramterized manipulators.
*       [AT&T C++]
*
*       [Public]
*
****/

#     _MSC_VER > 1000
#ָ once
#

#Ѷ  __cplusplus

#δ _INC_IOMANIP
# _INC_IOMANIP

#     !Ѷ(_WIN32) && !defined(_MAC)
# ERROR: Only Mac or Win32 targets supported!
#


#Ѷ  _MSC_VER
// Currently, all MS C compilers ѭ Win32 platforms ֵ to 8 byte
// alignment.
#ָ pack(push,8)

# <useoldio.h>

#  // _MSC_VER

# <iostream.h>

#Ѷ  _MSC_VER
#ָ warning(disable:4514)           // disable unwanted /W4 warning
// #ָ warning(ֵ:4514)        // use this to reenable,  necessary
#  // _MSC_VER

// # __MKMANIP(X) \# X##(T) __##X##_ \#\# T
// __MKMANIP(SMANIP);
// __MKMANIP(SAPP);
// __MKMANIP(IMANIP);
// __MKMANIP(IAPP);
// __MKMANIP(OMANIP);
// __MKMANIP(OAPP);
// __MKMANIP(IOMANIP);
// __MKMANIP(IOAPP);

# SMANIP(T) __SMANIP_##T
# SAPP(T) __SAPP_##T
# IMANIP(T) __IMANIP_##T
# IAPP(T) __IAPP_##T
# OMANIP(T) __OMANIP_##T
# OAPP(T) __OAPP_##T
# IOMANIP(T) __IOMANIP_##T
# IOAPP(T) __IOAPP_##T

# IOMANIPdeclare(T)  \
class SMANIP(T) { \
public: \
        SMANIP(T)(ios& (*f)(ios&,T), T t) : _fp(f), _tp(t) {} \
        friend istream& operator>>(istream& s, ֻ SMANIP(T) & sm) { (*(sm._fp))(s,sm._tp);  s; } \
        friend ostream& operator<<(ostream& s, ֻ SMANIP(T) & sm) { (*(sm._fp))(s,sm._tp);  s; } \
private:        \
        ios& (* _fp)(ios&,T); \
        T _tp; \
};      \
class SAPP(T) { \
public: \
        SAPP(T)( ios& (*f)(ios&,T)) : _fp(f) {} \
        SMANIP(T) operator()(T t) {  SMANIP(T)(_fp,t); }  \
private:        \
        ios& (* _fp)(ios&,T); \
};      \
class IMANIP(T) { \
public: \
        IMANIP(T)(istream& (*f)(istream&,T), T t) : _fp(f), _tp(t) {} \
        friend istream& operator>>(istream& s, IMANIP(T) & sm) { (*sm._fp)(s,sm._tp);  s; } \
private:        \
        istream& (* _fp)(istream&,T); \
        T _tp;  \
};      \
class IAPP(T) { \
public: \
        IAPP(T)( istream& (*f)(istream&,T)) : _fp(f) {} \
        IMANIP(T) operator()(T t) {  IMANIP(T)(_fp,t); }  \
private:        \
        istream& (* _fp)(istream&,T); \
};      \
class OMANIP(T) { \
public: \
        OMANIP(T)(ostream& (*f)(ostream&,T), T t) : _fp(f), _tp(t) {} \
        friend ostream& operator<<(ostream& s, OMANIP(T) & sm) { (*sm._fp)(s,sm._tp);  s; } \
private:        \
        ostream& (* _fp)(ostream&,T); \
        T _tp; \
};      \
class OAPP(T) { \
public: \
        OAPP(T)(ostream& (*f)(ostream&,T)) : _fp(f) {}  \
        OMANIP(T) operator()(T t) {  OMANIP(T)(_fp,t); } \
private:        \
        ostream& (* _fp)(ostream&,T); \
};      \
\
class IOMANIP(T) { \
public: \
        IOMANIP(T)(iostream& (*f)(iostream&,T), T t) : _fp(f), _tp(t) {} \
        friend istream& operator>>(iostream& s, IOMANIP(T) & sm) { (*sm._fp)(s,sm._tp);  s; } \
        friend ostream& operator<<(iostream& s, IOMANIP(T) & sm) { (*sm._fp)(s,sm._tp);  s; } \
private:        \
        iostream& (* _fp)(iostream&,T); \
        T _tp; \
};      \
class IOAPP(T) {        \
public: \
        IOAPP(T)( iostream& (*f)(iostream&,T)) : _fp(f) {}      \
        IOMANIP(T) operator()(T t) {  IOMANIP(T)(_fp,t); }        \
private:        \
        iostream& (* _fp)(iostream&,T); \
}; \

        
IOMANIPdeclare()

IOMANIPdeclare(long)

 ios& __resetiosflags(ios& s, long _flg) { s.setf(0,_flg);  s; }
 ios& __setfill(ios& s,  _fc) { s.fill((ַ)_fc);  s; }
 ios& __setiosflags(ios& s, long _flg) { s.setf(_flg);  s; }
 ios& __setprecision(ios& s,  _pre) { s.precision(_pre);  s; }
 ios& __setw(ios& s,  _wid) { s.width(_wid);  s; }

 SMANIP(long)     resetiosflags(long _l) {  SMANIP(long)(__resetiosflags, _l); }
 SMANIP()      setfill( _m) { SMANIP()(__setfill, _m); }
 SMANIP(long)     setiosflags(long _l) { SMANIP(long)(__setiosflags, _l); }
 SMANIP()      setprecision( _p) { SMANIP()(__setprecision, _p); }
 SMANIP()      setw( _w) {  SMANIP()(__setw, _w); }

// Restore previous packing
#Ѷ  _MSC_VER
#ָ pack(pop)
#  // _MSC_VER

#  // _INC_IOMANIP

#  /* __cplusplus */
