/***
*limits.h - implementation dependent values
*
*       Copyright (c) 1985-1997, Microsoft Corporation.  All rights reserved.
*
*Purpose:
*       Contains defines ѭ a number of implementation dependent values
*       which are commonly used in C programs.
*       [ANSI]
*
*       [Public]
*
****/

#     _MSC_VER > 1000
#ָ once
#

#δ _INC_LIMITS
# _INC_LIMITS

#     !Ѷ(_WIN32) && !defined(_MAC)
# ERROR: Only Mac or Win32 targets supported!
#


# CHAR_BIT      8         /* number of bits in a ַ */
# SCHAR_MIN   (-128)      /* minimum signed ַ value */
# SCHAR_MAX     127       /* maximum signed ַ value */
# UCHAR_MAX     0xff      /* maximum ޷ ַ value */

#δ _CHAR_UNSIGNED
# CHAR_MIN    SCHAR_MIN   /* mimimum ַ value */
# CHAR_MAX    SCHAR_MAX   /* maximum ַ value */
#
# CHAR_MIN      0
# CHAR_MAX    UCHAR_MAX
#  /* _CHAR_UNSIGNED */

# MB_LEN_MAX    2             /* max. # bytes in multibyte ַ */
# SHRT_MIN    (-32768)        /* minimum (signed)  value */
# SHRT_MAX      32767         /* maximum (signed)  value */
# USHRT_MAX     0xffff        /* maximum ޷  value */
# INT_MIN     (-2147483647 - 1) /* minimum (signed)  value */
# INT_MAX       2147483647    /* maximum (signed)  value */
# UINT_MAX      0xffffffff    /* maximum ޷  value */
# LONG_MIN    (-2147483647L - 1) /* minimum (signed) long value */
# LONG_MAX      2147483647L   /* maximum (signed) long value */
# ULONG_MAX     0xffffffffUL  /* maximum ޷ long value */

#     _INTEGRAL_MAX_BITS >= 8
# _I8_MIN     (-127i8 - 1)    /* minimum signed 8 bit value */
# _I8_MAX       127i8         /* maximum signed 8 bit value */
# _UI8_MAX      0xffui8       /* maximum ޷ 8 bit value */
#

#     _INTEGRAL_MAX_BITS >= 16
# _I16_MIN    (-32767i16 - 1) /* minimum signed 16 bit value */
# _I16_MAX      32767i16      /* maximum signed 16 bit value */
# _UI16_MAX     0xffffui16    /* maximum ޷ 16 bit value */
#

#     _INTEGRAL_MAX_BITS >= 32
# _I32_MIN    (-2147483647i32 - 1) /* minimum signed 32 bit value */
# _I32_MAX      2147483647i32 /* maximum signed 32 bit value */
# _UI32_MAX     0xffffffffui32 /* maximum ޷ 32 bit value */
#

#     _INTEGRAL_MAX_BITS >= 64
/* minimum signed 64 bit value */
# _I64_MIN    (-9223372036854775807i64 - 1)
/* maximum signed 64 bit value */
# _I64_MAX      9223372036854775807i64
/* maximum ޷ 64 bit value */
# _UI64_MAX     0xffffffffffffffffui64
#

#     _INTEGRAL_MAX_BITS >= 128
/* minimum signed 128 bit value */
# _I128_MIN   (-170141183460469231731687303715884105727i128 - 1)
/* maximum signed 128 bit value */
# _I128_MAX     170141183460469231731687303715884105727i128
/* maximum ޷ 128 bit value */
# _UI128_MAX    0xffffffffffffffffffffffffffffffffui128
#

#Ѷ  _POSIX_

# _POSIX_ARG_MAX      4096
# _POSIX_CHILD_MAX    6
# _POSIX_LINK_MAX     8
# _POSIX_MAX_CANON    255
# _POSIX_MAX_INPUT    255
# _POSIX_NAME_MAX     14
# _POSIX_NGROUPS_MAX  0
# _POSIX_OPEN_MAX     16
# _POSIX_PATH_MAX     255
# _POSIX_PIPE_BUF     512
# _POSIX_SSIZE_MAX    32767
# _POSIX_STREAM_MAX   8
# _POSIX_TZNAME_MAX   3

# ARG_MAX             14500       /* 16k heap, minus overhead */
# LINK_MAX            1024
# MAX_CANON           _POSIX_MAX_CANON
# MAX_INPUT           _POSIX_MAX_INPUT
# NAME_MAX            255
# NGROUPS_MAX         16
# OPEN_MAX            32
# PATH_MAX            512
# PIPE_BUF            _POSIX_PIPE_BUF
# SSIZE_MAX           _POSIX_SSIZE_MAX
# STREAM_MAX          20
# TZNAME_MAX          10

#  /* POSIX */

#  /* _INC_LIMITS */
