/***
*setjmp.h - definitions/declarations ѭ setjmp/longjmp routines
*
*       Copyright (c) 1985-1997, Microsoft Corporation. All rights reserved.
*
*Purpose:
*       This file defines the machine-dependent buffer used by
*       setjmp/longjmp to save and restore the program state, and
*       declarations ѭ those routines.
*       [ANSI/System V]
*
*       [Public]
*
****/

#     _MSC_VER > 1000
#ָ once
#

#δ _INC_SETJMP
# _INC_SETJMP

#     !Ѷ(_WIN32) && !defined(_MAC)
# ERROR: Only Mac or Win32 targets supported!
#


#Ѷ  _MSC_VER
/*
 * Currently, all MS C compilers ѭ Win32 platforms ֵ to 8 byte
 * alignment.
 */
#ָ pack(push,8)
#  /* _MSC_VER */

#Ѷ  __cplusplus
ⲿ "C" {
#



/* Define _CRTIMP */

#δ _CRTIMP
#Ѷ  _DLL
# _CRTIMP __declspec(dllimport)
#   /* ndef _DLL */
# _CRTIMP
#  /* _DLL */
#  /* _CRTIMP */

/* Define ϰ ѭ non-Microsoft compilers */

#     ( !Ѷ(_MSC_VER) && !defined(ϰ) )
# ϰ
#

/* Define _CRTAPI1 (ѭ compatibility with the NT SDK) */

#δ _CRTAPI1
#	_MSC_VER >= 800 && _M_IX86 >= 300
# _CRTAPI1 ϰ
#
# _CRTAPI1
#
#


/*
 * Definitions specific to particular setjmp implementations.
 */

#     Ѷ(_M_IX86)

/*
 * MS compiler ѭ x86
 */

#δ _INC_SETJMPEX
# setjmp  _setjmp
#

# _JBLEN  16
# _JBTYPE 

/*
 * Define jump buffer layout ѭ x86 setjmp/longjmp.
 */
Ͷ ṹ __JUMP_BUFFER {
    ޷ long Ebp;
    ޷ long Ebx;
    ޷ long Edi;
    ޷ long Esi;
    ޷ long Esp;
    ޷ long Eip;
    ޷ long Registration;
    ޷ long TryLevel;
    ޷ long Cookie;
    ޷ long UnwindFunc;
    ޷ long UnwindData[6];
} _JUMP_BUFFER;



#   Ѷ(_M_MRX000)

#δ _INC_SETJMPEX
#     _MSC_VER >= 1100
# _setjmp  _setjmpVfp
#
# setjmp  _setjmp
#

/*
 * All MIPS implementations need _JBLEN of 16
 */

# _JBLEN  16
# _JBTYPE ˫

/*
 * Define jump buffer layout ѭ MIPS setjmp/longjmp.
 */
Ͷ ṹ __JUMP_BUFFER {
    ޷ long FltF20;
    ޷ long FltF21;
    ޷ long FltF22;
    ޷ long FltF23;
    ޷ long FltF24;
    ޷ long FltF25;
    ޷ long FltF26;
    ޷ long FltF27;
    ޷ long FltF28;
    ޷ long FltF29;
    ޷ long FltF30;
    ޷ long FltF31;
    ޷ long IntS0;
    ޷ long IntS1;
    ޷ long IntS2;
    ޷ long IntS3;
    ޷ long IntS4;
    ޷ long IntS5;
    ޷ long IntS6;
    ޷ long IntS7;
    ޷ long IntS8;
    ޷ long IntSp;
    ޷ long Type;
    ޷ long Fir;
} _JUMP_BUFFER;


#   Ѷ(_M_ALPHA)

/*
 * The Alpha C8/GEM C compiler uses an intrinsic _setjmp.
 * The Alpha acc compiler implements setjmp as a function.
 */
#Ѷ  _MSC_VER
#δ _INC_SETJMPEX
# setjmp  _setjmp
#
#

/*
 * Alpha implementations use a _JBLEN of 24 quadwords.
 * A ˫ is used only to obtain quadword size and alignment.
 */
# _JBLEN  24
# _JBTYPE ˫

/*
 * Define jump buffer layout ѭ Alpha setjmp/longjmp.
 * A ˫ is used only to obtain quadword size and alignment.
 */
Ͷ ṹ __JUMP_BUFFER {
    ޷ long Fp;
    ޷ long Pc;
    ޷ long Seb;
    ޷ long Type;
    ˫ FltF2;
    ˫ FltF3;
    ˫ FltF4;
    ˫ FltF5;
    ˫ FltF6;
    ˫ FltF7;
    ˫ FltF8;
    ˫ FltF9;
    ˫ IntS0;
    ˫ IntS1;
    ˫ IntS2;
    ˫ IntS3;
    ˫ IntS4;
    ˫ IntS5;
    ˫ IntS6;
    ˫ IntSp;
    ˫ Fir;
    ˫ Fill[5];
} _JUMP_BUFFER;

#   Ѷ(_M_PPC)
/*
 * The Microsoft VC++ V4.0 compiler uses an intrinsic _setjmp.
 * The Motorola C8.5 compiler implements setjmp as a function.
 */

#     _MSC_VER > 850
#δ _INC_SETJMPEX
#ȡ _setjmp
# setjmp  _setjmp
#
#

/*
 * Min length is 240 bytes; round to 256 bytes.
 * Since this is allocated as an array of "double", the
 * number of entries required is 32.
 *
 * All PPC implementations need _JBLEN of 32
 */

# _JBLEN  32
# _JBTYPE ˫

/*
 * Define jump buffer layout ѭ PowerPC setjmp/longjmp.
 */

Ͷ ṹ __JUMP_BUFFER {
    ˫ Fpr14;
    ˫ Fpr15;
    ˫ Fpr16;
    ˫ Fpr17;
    ˫ Fpr18;
    ˫ Fpr19;
    ˫ Fpr20;
    ˫ Fpr21;
    ˫ Fpr22;
    ˫ Fpr23;
    ˫ Fpr24;
    ˫ Fpr25;
    ˫ Fpr26;
    ˫ Fpr27;
    ˫ Fpr28;
    ˫ Fpr29;
    ˫ Fpr30;
    ˫ Fpr31;
    ޷ long Gpr1;
    ޷ long Gpr2;
    ޷ long Gpr13;
    ޷ long Gpr14;
    ޷ long Gpr15;
    ޷ long Gpr16;
    ޷ long Gpr17;
    ޷ long Gpr18;
    ޷ long Gpr19;
    ޷ long Gpr20;
    ޷ long Gpr21;
    ޷ long Gpr22;
    ޷ long Gpr23;
    ޷ long Gpr24;
    ޷ long Gpr25;
    ޷ long Gpr26;
    ޷ long Gpr27;
    ޷ long Gpr28;
    ޷ long Gpr29;
    ޷ long Gpr30;
    ޷ long Gpr31;
    ޷ long Cr;
    ޷ long Iar;
    ޷ long Type;
} _JUMP_BUFFER;

#   Ѷ(_M_M68K)

#δ _INC_SETJMPEX
# setjmp  _setjmp
#

/* internal only ѭ version checking ѭ compatibility */
# _SETJMP_VER 1.0

/* internal only, jump buffer layout definition */
Ͷ ṹ __JUMP_BUFFER {
        ޷ long d1;       /* 0x00, saved */
        ޷ long d2;       /* 0x04, saved */
        ޷ long d3;       /* 0x08, saved */
        ޷ long d4;       /* 0x0c, saved */
        ޷ long d5;       /* 0x10, saved */
        ޷ long d6;       /* 0x14, saved */
        ޷ long d7;       /* 0x18, saved */
        ޷ long a1;       /* 0x1c, non-swappable version:  address,
                                         swappable version: swapper lib routine pointer ѭ building  address */
        ޷ long a2;       /* 0x20, saved */
        ޷ long a3;       /* 0x24, saved */
        ޷ long a4;       /* 0x28, saved */
        ޷ long a6;       /* 0x2c, saved */
        ޷ long a7;       /* 0x30, saved */
        ޷ long SwapChain; /* 0x34, without swapper: unused. with swapper: link swappable frames */
        ޷  reserved; /* 0x38, unused */
        ޷  SN;      /* 0x3a, swappable version: segment number */
        ޷ long BPC;      /* 0x3c, swappable version: offset within segment */
} _JUMP_BUFFER;

# _JBTYPE 
# _JBLEN  (ͳ(_JUMP_BUFFER)/ͳ(_JBTYPE))

#   Ѷ(_M_MPPC)

#δ _INC_SETJMPEX
# setjmp  _setjmp
#

# _JBTYPE 

/* define the buffer type ѭ building the state information */

# _JBLEN 64   /*  address, R1, R2, R13-R31, FPR14-FPR31, CR 2-5 */
#


/* Define the buffer type ѭ holding the state information */

#δ _JMP_BUF_DEFINED
Ͷ _JBTYPE jmp_buf[_JBLEN];
# _JMP_BUF_DEFINED
#


/* Function prototypes */

 ϰ setjmp(jmp_buf);

#     _MSC_VER >= 1200
_CRTIMP __declspec(noreturn)  ϰ longjmp(jmp_buf, );
#
_CRTIMP  ϰ longjmp(jmp_buf, );
#

#Ѷ  __cplusplus
}
#

#Ѷ  _MSC_VER
#ָ pack(pop)
#  /* _MSC_VER */

#  /* _INC_SETJMP */
