/***
*stdarg.h - defines ANSI-style macros ѭ variable argument functions
*
*       Copyright (c) 1985-1997, Microsoft Corporation. All rights reserved.
*
*Purpose:
*       This file defines ANSI-style macros ѭ accessing arguments
*       of functions which take a variable number of arguments.
*       [ANSI]
*
*       [Public]
*
****/

#     _MSC_VER > 1000
#ָ once
#

#δ _INC_STDARG
# _INC_STDARG

#     !Ѷ(_WIN32) && !defined(_MAC)
# ERROR: Only Mac or Win32 targets supported!
#


#Ѷ  _MSC_VER
/*
 * Currently, all MS C compilers ѭ Win32 platforms ֵ to 8 byte
 * alignment.
 */
#ָ pack(push,8)
#  /* _MSC_VER */

#Ѷ  __cplusplus
ⲿ "C" {
#



#δ _VA_LIST_DEFINED
#Ѷ  _M_ALPHA
Ͷ ṹ {
        ַ *a0;       /* pointer to first homed integer argument */
         offset;     /* byte offset of next parameter */
} va_list;
#
Ͷ ַ *  va_list;
#
# _VA_LIST_DEFINED
#

#Ѷ  _M_IX86


# _INTSIZEOF(n)   ( (ͳ(n) + ͳ() - 1) & ~(ͳ() - 1) )

# va_start(ap,v)  ( ap = (va_list)&v + _INTSIZEOF(v) )
# va_arg(ap,t)    ( *(t *)((ap += _INTSIZEOF(t)) - _INTSIZEOF(t)) )
# va_end(ap)      ( ap = (va_list)0 )

#   Ѷ(_M_MRX000)


/* Use these types and definitions  generating code ѭ MIPS */

# va_start(ap,v) ap  = (va_list)&v + ͳ(v)
# va_end(list)
# va_arg(list, mode) ((mode *)(list =\
 (ַ *) (((()list + (__builtin_alignof(mode)<=4?3:7)) &\
 (__builtin_alignof(mode)<=4?-4:-8))+ͳ(mode))))[-1]

/*  +++++++++++++++++++++++++++++++++++++++++++
    Because of parameter passing conventions in C:
    use mode= ѭ ַ, and  types
    use mode=˫ ѭ  types
    use a pointer ѭ array types
    +++++++++++++++++++++++++++++++++++++++++++ */


#   Ѷ(_M_ALPHA)


/* Use these types and definitions  generating code ѭ ALPHA */

/*
 * The Alpha compiler supports two builtin functions that are used to
 * implement stdarg/varargs.  The __builtin_va_start function is used
 * by va_start to initialize the data structure that locates the next
 * argument.  The __builtin_isfloat function is used by va_arg to pick
 * which part of the home area a given Ĵ argument is stored in.
 * The home area is where up to six integer and/or six floating point
 * Ĵ arguments are stored down (so they can also be referenced
 * by a pointer like any arguments passed on the stack).
 */

ⲿ  * __builtin_va_start(va_list, ...);

#Ѷ  _CFRONT
# __builtin_isfloat(a) __builtin_alignof(a)
#

# va_start(list, v) __builtin_va_start(list, v, 1)
# va_end(list)
# va_arg(list, mode) \
    ( *(        ((list).offset += (()ͳ(mode) + 7) & -8) , \
        (mode *)((list).a0 + (list).offset - \
                    ((__builtin_isfloat(mode) && (list).offset <= (6 * 8)) ? \
                        (6 * 8) + 8 : (()ͳ(mode) + 7) & -8) \
                ) \
       ) \
    )

#   Ѷ(_M_PPC)

/* Microsoft C8 front end (used in Motorola Merged compiler) */
/* bytes that a type occupies in the argument list */
# _INTSIZEOF(n)   ( (ͳ(n) + ͳ() - 1) & ~(ͳ() - 1) )
/*  'ap' adjusted ѭ type 't' in arglist */
# _ALIGNIT(ap,t) \
        (((()(ap))+(ͳ(t)<8?3:7)) & (ͳ(t)<8?~3:~7))

# va_start(ap,v)  ( ap = (va_list)&v + _INTSIZEOF(v) )
# va_arg(ap,t)    ( *(t *)((ap = (ַ *) (_ALIGNIT(ap, t) + _INTSIZEOF(t))) - _INTSIZEOF(t)) )
# va_end(ap)      ( ap = (va_list)0 )

#   Ѷ(_M_M68K)
# _INTSIZEOF(n)   ( (ͳ(n) + ͳ() - 1) & ~(ͳ() - 1) )

# va_start(ap,v)  ( ap = (va_list)&v + (ͳ(v) < ͳ() ? ͳ(v) : _INTSIZEOF(v)) )
# va_arg(ap,t)    ( *(t *)((ap += _INTSIZEOF(t)) - _INTSIZEOF(t)) )
# va_end(ap)      ( ap = (va_list)0 )

#   Ѷ(_M_MPPC)
# _INTSIZEOF(n)   ( (ͳ(n) + ͳ() - 1) & ~(ͳ() - 1) )

# va_start(ap,v)  ( ap = (va_list)&v + _INTSIZEOF(v) )
# va_arg(ap,t)    ( *(t *)((ap += _INTSIZEOF(t)) - _INTSIZEOF(t)) )
# va_end(ap)      ( ap = (va_list)0 )

#

/* A guess at the proper definitions ѭ other platforms */

# _INTSIZEOF(n)   ( (ͳ(n) + ͳ() - 1) & ~(ͳ() - 1) )

# va_start(ap,v)  ( ap = (va_list)&v + _INTSIZEOF(v) )
# va_arg(ap,t)    ( *(t *)((ap += _INTSIZEOF(t)) - _INTSIZEOF(t)) )
# va_end(ap)      ( ap = (va_list)0 )


#


#Ѷ  __cplusplus
}
#

#Ѷ  _MSC_VER
#ָ pack(pop)
#  /* _MSC_VER */

#  /* _INC_STDARG */
