/***
*stdio.h - definitions/declarations ѭ standard I/O routines
*
*       Copyright (c) 1985-1997, Microsoft Corporation. All rights reserved.
*
*Purpose:
*       This file defines the structures, values, macros, and functions
*       used by the level 2 I/O ("standard I/O") routines.
*       [ANSI/System V]
*
*       [Public]
*
****/

#     _MSC_VER > 1000
#ָ once
#

#δ _INC_STDIO
# _INC_STDIO

#     !Ѷ(_WIN32) && !defined(_MAC)
# ERROR: Only Mac or Win32 targets supported!
#


#Ѷ  _MSC_VER
/*
 * Currently, all MS C compilers ѭ Win32 platforms ֵ to 8 byte
 * alignment.
 */
#ָ pack(push,8)
#  /* _MSC_VER */

#Ѷ  __cplusplus
ⲿ "C" {
#



/* Define _CRTIMP */

#δ _CRTIMP
#Ѷ  _DLL
# _CRTIMP __declspec(dllimport)
#   /* ndef _DLL */
# _CRTIMP
#  /* _DLL */
#  /* _CRTIMP */


/* Define ϰ ѭ non-Microsoft compilers */

#     ( !Ѷ(_MSC_VER) && !defined(ϰ) )
# ϰ
#

/* Define _CRTAPI1 (ѭ compatibility with the NT SDK) */

#δ _CRTAPI1
#	_MSC_VER >= 800 && _M_IX86 >= 300
# _CRTAPI1 ϰ
#
# _CRTAPI1
#
#


#δ _SIZE_T_DEFINED
Ͷ ޷  size_t;
# _SIZE_T_DEFINED
#


#δ _MAC
#δ _WCHAR_T_DEFINED
Ͷ ޷  wchar_t;
# _WCHAR_T_DEFINED
#


#δ _WCTYPE_T_DEFINED
Ͷ wchar_t wint_t;
Ͷ wchar_t wctype_t;
# _WCTYPE_T_DEFINED
#
# /* ndef _MAC */


#δ _VA_LIST_DEFINED
#Ѷ  _M_ALPHA
Ͷ ṹ {
        ַ *a0;       /* pointer to first homed integer argument */
         offset;     /* byte offset of next parameter */
} va_list;
#
Ͷ ַ *  va_list;
#
# _VA_LIST_DEFINED
#


/* Buffered I/O macros */

#     Ѷ(_M_MPPC)
# BUFSIZ  4096
#  /* defined (_M_MPPC) */
# BUFSIZ  512
# /* defined (_M_MPPC) */


/*
 * Default number of supported streams. _NFILE is confusing and obsolete, but
 * supported anyway ѭ backwards compatibility.
 */
# _NFILE      _NSTREAM_

#Ѷ  _WIN32

# _NSTREAM_   512

/*
 * Number of entries in _iob[] (declared below). Note that _NSTREAM_ must be
 * greater than or equal to _IOB_ENTRIES.
 */
# _IOB_ENTRIES 20

#   /* ndef _WIN32 */

#Ѷ  _DLL
# _NSTREAM_   128
#
#Ѷ  _MT
# _NSTREAM_   40
#
# _NSTREAM_   20
#
#  /* _DLL */

#  /* ndef _MAC */

# EOF     (-1)


#δ _FILE_DEFINED
ṹ _iobuf {
        ַ *_ptr;
           _cnt;
        ַ *_base;
           _flag;
           _file;
           _charbuf;
           _bufsiz;
        ַ *_tmpfname;
        };
Ͷ ṹ _iobuf FILE;
# _FILE_DEFINED
#


#δ _MAC

/* Directory where temporary files may be created. */

#Ѷ  _POSIX_
# _P_tmpdir   "/"
# _wP_tmpdir  L"/"
#
# _P_tmpdir   "\\"
# _wP_tmpdir  L"\\"
#

/* L_tmpnam = size of P_tmpdir
 *            + 1 (in  P_tmpdir does not end in "/")
 *            + 12 (ѭ the filename string)
 *            + 1 (ѭ the null terminator)
 */
# L_tmpnam ͳ(_P_tmpdir)+12

#   /* def _MAC */

# L_tmpnam 255

#  /* _MAC */


#Ѷ  _POSIX_
# L_ctermid   9
# L_cuserid   32
#


/* Seek method constants */

# SEEK_CUR    1
# SEEK_END    2
# SEEK_SET    0


# FILENAME_MAX    260
# FOPEN_MAX       20
# _SYS_OPEN       20
# TMP_MAX         32767


/* Define NULL pointer value */

#δ NULL
#Ѷ  __cplusplus
# NULL    0
#
# NULL    (( *)0)
#
#


/* Declare _iob[] array */

#δ _STDIO_DEFINED
_CRTIMP ⲿ FILE _iob[];
#  /* _STDIO_DEFINED */


/* Define file position type */

#δ _FPOS_T_DEFINED
#ȡ _FPOSOFF

# Ѷ (_POSIX_)
Ͷ long fpos_t;
# /* _POSIX_ */

#     !__STDC__ && _INTEGRAL_MAX_BITS >= 64
Ͷ  fpos_t;
# _FPOSOFF(fp) ((long)(fp))
#
Ͷ ṹ fpos_t {
        ޷  lopart;
                  hipart;
        } fpos_t;
# _FPOSOFF(fp) ((long)(fp).lopart)
#
#  /* _POSIX_ */

# _FPOS_T_DEFINED
#


# stdin  (&_iob[0])
# stdout (&_iob[1])
# stderr (&_iob[2])


# _IOREAD         0x0001
# _IOWRT          0x0002

# _IOFBF          0x0000
# _IOLBF          0x0040
# _IONBF          0x0004

# _IOMYBUF        0x0008
# _IOEOF          0x0010
# _IOERR          0x0020
# _IOSTRG         0x0040
# _IORW           0x0080
#Ѷ _POSIX_
# _IOAPPEND       0x0200
#


/* Function prototypes */

#δ _STDIO_DEFINED

_CRTIMP  ϰ _filbuf(FILE *);
_CRTIMP  ϰ _flsbuf(, FILE *);

#Ѷ  _POSIX_
_CRTIMP FILE * ϰ _fsopen(ֻ ַ *, ֻ ַ *);
#
_CRTIMP FILE * ϰ _fsopen(ֻ ַ *, ֻ ַ *, );
#

_CRTIMP  ϰ clearerr(FILE *);
_CRTIMP  ϰ fclose(FILE *);
_CRTIMP  ϰ _fcloseall();

#Ѷ  _POSIX_
_CRTIMP FILE * ϰ fdopen(, ֻ ַ *);
#
_CRTIMP FILE * ϰ _fdopen(, ֻ ַ *);
#

_CRTIMP  ϰ feof(FILE *);
_CRTIMP  ϰ ferror(FILE *);
_CRTIMP  ϰ fflush(FILE *);
_CRTIMP  ϰ fgetc(FILE *);
_CRTIMP  ϰ _fgetchar();
_CRTIMP  ϰ fgetpos(FILE *, fpos_t *);
_CRTIMP ַ * ϰ fgets(ַ *, , FILE *);

#Ѷ  _POSIX_
_CRTIMP  ϰ fileno(FILE *);
#
_CRTIMP  ϰ _fileno(FILE *);
#

_CRTIMP  ϰ _flushall();
_CRTIMP FILE * ϰ fopen(ֻ ַ *, ֻ ַ *);
_CRTIMP  ϰ fprintf(FILE *, ֻ ַ *, ...);
_CRTIMP  ϰ fputc(, FILE *);
_CRTIMP  ϰ _fputchar();
_CRTIMP  ϰ fputs(ֻ ַ *, FILE *);
_CRTIMP size_t ϰ fread( *, size_t, size_t, FILE *);
_CRTIMP FILE * ϰ freopen(ֻ ַ *, ֻ ַ *, FILE *);
_CRTIMP  ϰ fscanf(FILE *, ֻ ַ *, ...);
_CRTIMP  ϰ fsetpos(FILE *, ֻ fpos_t *);
_CRTIMP  ϰ fseek(FILE *, long, );
_CRTIMP long ϰ ftell(FILE *);
_CRTIMP size_t ϰ fwrite(ֻ  *, size_t, size_t, FILE *);
_CRTIMP  ϰ getc(FILE *);
_CRTIMP  ϰ getchar();
_CRTIMP  ϰ _getmaxstdio();
_CRTIMP ַ * ϰ gets(ַ *);
_CRTIMP  ϰ _getw(FILE *);
_CRTIMP  ϰ perror(ֻ ַ *);
_CRTIMP  ϰ _pclose(FILE *);
_CRTIMP FILE * ϰ _popen(ֻ ַ *, ֻ ַ *);
_CRTIMP  ϰ printf(ֻ ַ *, ...);
_CRTIMP  ϰ putc(, FILE *);
_CRTIMP  ϰ putchar();
_CRTIMP  ϰ puts(ֻ ַ *);
_CRTIMP  ϰ _putw(, FILE *);
_CRTIMP  ϰ remove(ֻ ַ *);
_CRTIMP  ϰ rename(ֻ ַ *, ֻ ַ *);
_CRTIMP  ϰ rewind(FILE *);
_CRTIMP  ϰ _rmtmp();
_CRTIMP  ϰ scanf(ֻ ַ *, ...);
_CRTIMP  ϰ setbuf(FILE *, ַ *);
_CRTIMP  ϰ _setmaxstdio();
_CRTIMP  ϰ setvbuf(FILE *, ַ *, , size_t);
_CRTIMP  ϰ _snprintf(ַ *, size_t, ֻ ַ *, ...);
_CRTIMP  ϰ sprintf(ַ *, ֻ ַ *, ...);
_CRTIMP  ϰ sscanf(ֻ ַ *, ֻ ַ *, ...);
_CRTIMP ַ * ϰ _tempnam(ֻ ַ *, ֻ ַ *);
_CRTIMP FILE * ϰ tmpfile();
_CRTIMP ַ * ϰ tmpnam(ַ *);
_CRTIMP  ϰ ungetc(, FILE *);
_CRTIMP  ϰ _unlink(ֻ ַ *);
_CRTIMP  ϰ vfprintf(FILE *, ֻ ַ *, va_list);
_CRTIMP  ϰ vprintf(ֻ ַ *, va_list);
_CRTIMP  ϰ _vsnprintf(ַ *, size_t, ֻ ַ *, va_list);
_CRTIMP  ϰ vsprintf(ַ *, ֻ ַ *, va_list);

#δ _MAC
#δ _WSTDIO_DEFINED

/* wide function prototypes, also declared in wchar.h  */

#δ WEOF
# WEOF (wint_t)(0xFFFF)
#

#Ѷ  _POSIX_
_CRTIMP FILE * ϰ _wfsopen(ֻ wchar_t *, ֻ wchar_t *);
#
_CRTIMP FILE * ϰ _wfsopen(ֻ wchar_t *, ֻ wchar_t *, );
#

_CRTIMP wint_t ϰ fgetwc(FILE *);
_CRTIMP wint_t ϰ _fgetwchar();
_CRTIMP wint_t ϰ fputwc(wint_t, FILE *);
_CRTIMP wint_t ϰ _fputwchar(wint_t);
_CRTIMP wint_t ϰ getwc(FILE *);
_CRTIMP wint_t ϰ getwchar();
_CRTIMP wint_t ϰ putwc(wint_t, FILE *);
_CRTIMP wint_t ϰ putwchar(wint_t);
_CRTIMP wint_t ϰ ungetwc(wint_t, FILE *);

_CRTIMP wchar_t * ϰ fgetws(wchar_t *, , FILE *);
_CRTIMP  ϰ fputws(ֻ wchar_t *, FILE *);
_CRTIMP wchar_t * ϰ _getws(wchar_t *);
_CRTIMP  ϰ _putws(ֻ wchar_t *);

_CRTIMP  ϰ fwprintf(FILE *, ֻ wchar_t *, ...);
_CRTIMP  ϰ wprintf(ֻ wchar_t *, ...);
_CRTIMP  ϰ _snwprintf(wchar_t *, size_t, ֻ wchar_t *, ...);
_CRTIMP  ϰ swprintf(wchar_t *, ֻ wchar_t *, ...);
_CRTIMP  ϰ vfwprintf(FILE *, ֻ wchar_t *, va_list);
_CRTIMP  ϰ vwprintf(ֻ wchar_t *, va_list);
_CRTIMP  ϰ _vsnwprintf(wchar_t *, size_t, ֻ wchar_t *, va_list);
_CRTIMP  ϰ vswprintf(wchar_t *, ֻ wchar_t *, va_list);
_CRTIMP  ϰ fwscanf(FILE *, ֻ wchar_t *, ...);
_CRTIMP  ϰ swscanf(ֻ wchar_t *, ֻ wchar_t *, ...);
_CRTIMP  ϰ wscanf(ֻ wchar_t *, ...);

# getwchar()              fgetwc(stdin)
# putwchar(_c)            fputwc((_c),stdout)
# getwc(_stm)             fgetwc(_stm)
# putwc(_c,_stm)          fputwc(_c,_stm)

_CRTIMP FILE * ϰ _wfdopen(, ֻ wchar_t *);
_CRTIMP FILE * ϰ _wfopen(ֻ wchar_t *, ֻ wchar_t *);
_CRTIMP FILE * ϰ _wfreopen(ֻ wchar_t *, ֻ wchar_t *, FILE *);
_CRTIMP  ϰ _wperror(ֻ wchar_t *);
_CRTIMP FILE * ϰ _wpopen(ֻ wchar_t *, ֻ wchar_t *);
_CRTIMP  ϰ _wremove(ֻ wchar_t *);
_CRTIMP wchar_t * ϰ _wtempnam(ֻ wchar_t *, ֻ wchar_t *);
_CRTIMP wchar_t * ϰ _wtmpnam(wchar_t *);


# _WSTDIO_DEFINED
#  /* _WSTDIO_DEFINED */
# /* ndef _MAC */

# _STDIO_DEFINED
#  /* _STDIO_DEFINED */


/* Macro definitions */

# feof(_stream)     ((_stream)->_flag & _IOEOF)
# ferror(_stream)   ((_stream)->_flag & _IOERR)
# _fileno(_stream)  ((_stream)->_file)
# getc(_stream)     (--(_stream)->_cnt >= 0 \
                ? 0xff & *(_stream)->_ptr++ : _filbuf(_stream))
# putc(_c,_stream)  (--(_stream)->_cnt >= 0 \
                ? 0xff & (*(_stream)->_ptr++ = (ַ)(_c)) :  _flsbuf((_c),(_stream)))
# getchar()         getc(stdin)
# putchar(_c)       putc((_c),stdout)



#Ѷ  _MT
#ȡ  getc
#ȡ  putc
#ȡ  getchar
#ȡ  putchar
#



#     !__STDC__ && !Ѷ(_POSIX_)

/* Non-ANSI names ѭ compatibility */

# P_tmpdir  _P_tmpdir
# SYS_OPEN  _SYS_OPEN

_CRTIMP  ϰ fcloseall();
_CRTIMP FILE * ϰ fdopen(, ֻ ַ *);
_CRTIMP  ϰ fgetchar();
_CRTIMP  ϰ fileno(FILE *);
_CRTIMP  ϰ flushall();
_CRTIMP  ϰ fputchar();
_CRTIMP  ϰ getw(FILE *);
_CRTIMP  ϰ putw(, FILE *);
_CRTIMP  ϰ rmtmp();
_CRTIMP ַ * ϰ tempnam(ֻ ַ *, ֻ ַ *);
_CRTIMP  ϰ unlink(ֻ ַ *);

#  /* __STDC__ */

#Ѷ  __cplusplus
}
#

#Ѷ  _MSC_VER
#ָ pack(pop)
#  /* _MSC_VER */

#  /* _INC_STDIO */
