/***
*stdlib.h - declarations/definitions ѭ commonly used library functions
*
*       Copyright (c) 1985-1997, Microsoft Corporation. All rights reserved.
*
*Purpose:
*       This include file contains the function declarations ѭ commonly
*       used library functions which either don't fit somewhere else, or,
*       cannot be declared in the normal place ѭ other reasons.
*       [ANSI]
*
*       [Public]
*
****/

#     _MSC_VER > 1000
#ָ once
#

#δ _INC_STDLIB
# _INC_STDLIB

#     !Ѷ(_WIN32) && !defined(_MAC)
# ERROR: Only Mac or Win32 targets supported!
#


#Ѷ  _MSC_VER
/*
 * Currently, all MS C compilers ѭ Win32 platforms ֵ to 8 byte
 * alignment.
 */
#ָ pack(push,8)
#  /* _MSC_VER */

#Ѷ  __cplusplus
ⲿ "C" {
#



/* Define _CRTIMP */

#δ _CRTIMP
#Ѷ  _DLL
# _CRTIMP __declspec(dllimport)
#   /* ndef _DLL */
# _CRTIMP
#  /* _DLL */
#  /* _CRTIMP */


/* Define ϰ ѭ non-Microsoft compilers */

#     ( !Ѷ(_MSC_VER) && !defined(ϰ) )
# ϰ
#

/* Define _CRTAPI1 (ѭ compatibility with the NT SDK) */

#δ _CRTAPI1
#	_MSC_VER >= 800 && _M_IX86 >= 300
# _CRTAPI1 ϰ
#
# _CRTAPI1
#
#


#δ _SIZE_T_DEFINED
Ͷ ޷  size_t;
# _SIZE_T_DEFINED
#


#δ _WCHAR_T_DEFINED
Ͷ ޷  wchar_t;
# _WCHAR_T_DEFINED
#


/* Define NULL pointer value */

#δ NULL
#Ѷ __cplusplus
# NULL    0
#
# NULL    (( *)0)
#
#


/* Definition of the argument values ѭ the exit() function */

# EXIT_SUCCESS    0
# EXIT_FAILURE    1


#δ _ONEXIT_T_DEFINED
Ͷ  (ϰ * _onexit_t)();
#     !__STDC__
/* Non-ANSI name ѭ compatibility */
# onexit_t _onexit_t
#
# _ONEXIT_T_DEFINED
#


/* Data structure definitions ѭ div and ldiv runtimes. */

#δ _DIV_T_DEFINED

Ͷ ṹ _div_t {
         quot;
         rem;
} div_t;

Ͷ ṹ _ldiv_t {
        long quot;
        long rem;
} ldiv_t;

# _DIV_T_DEFINED
#


/* Maximum value that can be returned by the rand function. */

# RAND_MAX 0x7fff

/*
 * Maximum number of bytes in multi-byte character in the current locale
 * (also defined in ctype.h).
 */
#δ MB_CUR_MAX
# MB_CUR_MAX __mb_cur_max
_CRTIMP ⲿ  __mb_cur_max;
#  /* MB_CUR_MAX */


/* Minimum and maximum macros */

# __max(a,b)  (((a) > (b)) ? (a) : (b))
# __min(a,b)  (((a) < (b)) ? (a) : (b))

/*
 * Sizes ѭ buffers used by the _makepath() and _splitpath() functions.
 * note that the sizes include space ѭ 0-terminator
 */
#δ _MAC
# _MAX_PATH   260 /* max. length of full pathname */
# _MAX_DRIVE  3   /* max. length of drive component */
# _MAX_DIR    256 /* max. length of path component */
# _MAX_FNAME  256 /* max. length of file name component */
# _MAX_EXT    256 /* max. length of extension component */
#   /* def _MAC */
# _MAX_PATH   256 /* max. length of full pathname */
# _MAX_DIR    32  /* max. length of path component */
# _MAX_FNAME  64  /* max. length of file name component */
#  /* _MAC */

/*
 * Argument values ѭ _set_error_mode().
 */
# _OUT_TO_DEFAULT 0
# _OUT_TO_STDERR  1
# _OUT_TO_MSGBOX  2
# _REPORT_ERRMODE 3


/* External variable declarations */

#     (Ѷ(_MT) || defined(_DLL)) && !defined(_MAC)
_CRTIMP  * ϰ _errno();
_CRTIMP ޷ long * ϰ __doserrno();
# errno       (*_errno())
# _doserrno   (*__doserrno())
#   /* ndef _MT && ndef _DLL */
_CRTIMP ⲿ  errno;               /* XENIX style error number */
_CRTIMP ⲿ ޷ long _doserrno; /* OS system error value */
#  /* _MT || _DLL */


#Ѷ  _MAC
_CRTIMP ⲿ   _macerrno;          /* OS system error value */
#


_CRTIMP ⲿ ַ * _sys_errlist[];   /* perror error message table */
_CRTIMP ⲿ  _sys_nerr;           /* # of entries in sys_errlist table */


#     Ѷ(_DLL) && defined(_M_IX86)

# __argc      (*__p___argc())     /* count of cmd  args */
# __argv      (*__p___argv())     /* pointer to table of cmd  args */
# __wargv     (*__p___wargv())    /* pointer to table of wide cmd  args */
# _environ    (*__p__environ())   /* pointer to environment table */
#Ѷ _POSIX_
ⲿ ַ ** environ;                 /* pointer to environment table */
#
#δ _MAC
# _wenviron   (*__p__wenviron())  /* pointer to wide environment table */
#  /* ndef _MAC */
# /* _POSIX_ */
# _pgmptr     (*__p__pgmptr())    /* points to the module (EXE) name */
#δ _MAC
# _wpgmptr    (*__p__wpgmptr())   /* points to the module (EXE) wide name */
#  /* ndef _MAC */

_CRTIMP  *          ϰ __p___argc();
_CRTIMP ַ ***       ϰ __p___argv();
_CRTIMP wchar_t ***    ϰ __p___wargv();
_CRTIMP ַ ***       ϰ __p__environ();
_CRTIMP wchar_t ***    ϰ __p__wenviron();
_CRTIMP ַ **        ϰ __p__pgmptr();
_CRTIMP wchar_t **     ϰ __p__wpgmptr();


#

_CRTIMP ⲿ  __argc;          /* count of cmd line args */
_CRTIMP ⲿ ַ ** __argv;      /* pointer to table of cmd line args */
#δ _MAC
_CRTIMP ⲿ wchar_t ** __wargv;  /* pointer to table of wide cmd line args */
#  /* ndef _MAC */

#Ѷ _POSIX_
ⲿ ַ ** environ;             /* pointer to environment table */
#
_CRTIMP ⲿ ַ ** _environ;    /* pointer to environment table */
#δ _MAC
_CRTIMP ⲿ wchar_t ** _wenviron;    /* pointer to wide environment table */
#  /* ndef _MAC */
#  /* _POSIX_ */

_CRTIMP ⲿ ַ * _pgmptr;      /* points to the module (EXE) name */
#δ _MAC
_CRTIMP ⲿ wchar_t * _wpgmptr;  /* points to the module (EXE) wide name */
#  /* ndef _MAC */

#


_CRTIMP ⲿ  _fmode;          /* ֵ file translation mode */
_CRTIMP ⲿ  _fileinfo;       /* open file info mode (ѭ spawn) */


/* Windows major/minor and O.S. version numbers */

_CRTIMP ⲿ ޷  _osver;
_CRTIMP ⲿ ޷  _winver;
_CRTIMP ⲿ ޷  _winmajor;
_CRTIMP ⲿ ޷  _winminor;


/* function prototypes */

#     _MSC_VER >= 1200
_CRTIMP __declspec(noreturn)    ϰ abort();
_CRTIMP __declspec(noreturn)    ϰ exit();
#
_CRTIMP    ϰ abort();
_CRTIMP    ϰ exit();
#

# Ѷ(_M_MRX000)
_CRTIMP     ϰ abs();
#
            ϰ abs();
#
            ϰ atexit( (ϰ *)());
_CRTIMP ˫ ϰ atof(ֻ ַ *);
_CRTIMP     ϰ atoi(ֻ ַ *);
_CRTIMP long   ϰ atol(ֻ ַ *);
#Ѷ  _M_M68K
_CRTIMP long ˫ ϰ _atold(ֻ ַ *);
#
_CRTIMP  * ϰ bsearch(ֻ  *, ֻ  *, size_t, size_t,
         (ϰ *)(ֻ  *, ֻ  *));
_CRTIMP  * ϰ calloc(size_t, size_t);
_CRTIMP div_t  ϰ div(, );
_CRTIMP    ϰ free( *);
_CRTIMP ַ * ϰ getenv(ֻ ַ *);
_CRTIMP ַ * ϰ _itoa(, ַ *, );
#     _INTEGRAL_MAX_BITS >= 64
_CRTIMP ַ * ϰ _i64toa(, ַ *, );
_CRTIMP ַ * ϰ _ui64toa(޷ , ַ *, );
_CRTIMP  ϰ _atoi64(ֻ ַ *);
#
#     Ѷ(_M_MRX000)
_CRTIMP long ϰ labs(long);
#
        long ϰ labs(long);
#
_CRTIMP ldiv_t ϰ ldiv(long, long);
_CRTIMP ַ * ϰ _ltoa(long, ַ *, );
_CRTIMP  * ϰ malloc(size_t);
_CRTIMP     ϰ mblen(ֻ ַ *, size_t);
_CRTIMP size_t ϰ _mbstrlen(ֻ ַ *s);
_CRTIMP     ϰ mbtowc(wchar_t *, ֻ ַ *, size_t);
_CRTIMP size_t ϰ mbstowcs(wchar_t *, ֻ ַ *, size_t);
_CRTIMP    ϰ qsort( *, size_t, size_t,  (ϰ *)
        (ֻ  *, ֻ  *));
_CRTIMP     ϰ rand();
_CRTIMP  * ϰ realloc( *, size_t);
_CRTIMP     ϰ _set_error_mode();
_CRTIMP    ϰ srand(޷ );
_CRTIMP ˫ ϰ strtod(ֻ ַ *, ַ **);
_CRTIMP long   ϰ strtol(ֻ ַ *, ַ **, );
#Ѷ  _M_M68K
_CRTIMP long ˫ ϰ _strtold(ֻ ַ *, ַ **);
#
_CRTIMP ޷ long ϰ strtoul(ֻ ַ *, ַ **, );
#δ _MAC
_CRTIMP     ϰ system(ֻ ַ *);
#
_CRTIMP ַ * ϰ _ultoa(޷ long, ַ *, );
_CRTIMP     ϰ wctomb(ַ *, wchar_t);
_CRTIMP size_t ϰ wcstombs(ַ *, ֻ wchar_t *, size_t);


#δ _MAC
#δ _WSTDLIB_DEFINED

/* wide function prototypes, also declared in wchar.h  */

_CRTIMP wchar_t * ϰ _itow (, wchar_t *, );
_CRTIMP wchar_t * ϰ _ltow (long, wchar_t *, );
_CRTIMP wchar_t * ϰ _ultow (޷ long, wchar_t *, );
_CRTIMP ˫ ϰ wcstod(ֻ wchar_t *, wchar_t **);
_CRTIMP long   ϰ wcstol(ֻ wchar_t *, wchar_t **, );
_CRTIMP ޷ long ϰ wcstoul(ֻ wchar_t *, wchar_t **, );
_CRTIMP wchar_t * ϰ _wgetenv(ֻ wchar_t *);
_CRTIMP     ϰ _wsystem(ֻ wchar_t *);
_CRTIMP  ϰ _wtoi(ֻ wchar_t *);
_CRTIMP long ϰ _wtol(ֻ wchar_t *);
#     _INTEGRAL_MAX_BITS >= 64
_CRTIMP wchar_t * ϰ _i64tow(, wchar_t *, );
_CRTIMP wchar_t * ϰ _ui64tow(޷ , wchar_t *, );
_CRTIMP    ϰ _wtoi64(ֻ wchar_t *);
#

# _WSTDLIB_DEFINED
#
#  /* ndef _MAC */


#δ _POSIX_

_CRTIMP ַ * ϰ _ecvt(˫, ,  *,  *);
#     _MSC_VER >= 1200
_CRTIMP __declspec(noreturn)    ϰ _exit();
#
_CRTIMP    ϰ _exit();
#
_CRTIMP ַ * ϰ _fcvt(˫, ,  *,  *);
_CRTIMP ַ * ϰ _fullpath(ַ *, ֻ ַ *, size_t);
_CRTIMP ַ * ϰ _gcvt(˫, , ַ *);
        ޷ long ϰ _lrotl(޷ long, );
        ޷ long ϰ _lrotr(޷ long, );
#δ _MAC
_CRTIMP    ϰ _makepath(ַ *, ֻ ַ *, ֻ ַ *, ֻ ַ *,
        ֻ ַ *);
#
        _onexit_t ϰ _onexit(_onexit_t);
_CRTIMP    ϰ perror(ֻ ַ *);
_CRTIMP     ϰ _putenv(ֻ ַ *);
        ޷  ϰ _rotl(޷ , );
        ޷  ϰ _rotr(޷ , );
_CRTIMP    ϰ _searchenv(ֻ ַ *, ֻ ַ *, ַ *);
#δ _MAC
_CRTIMP    ϰ _splitpath(ֻ ַ *, ַ *, ַ *, ַ *, ַ *);
#
_CRTIMP    ϰ _swab(ַ *, ַ *, );

#δ _MAC
#δ _WSTDLIBP_DEFINED

/* wide function prototypes, also declared in wchar.h  */

_CRTIMP wchar_t * ϰ _wfullpath(wchar_t *, ֻ wchar_t *, size_t);
_CRTIMP    ϰ _wmakepath(wchar_t *, ֻ wchar_t *, ֻ wchar_t *, ֻ wchar_t *,
        ֻ wchar_t *);
_CRTIMP    ϰ _wperror(ֻ wchar_t *);
_CRTIMP     ϰ _wputenv(ֻ wchar_t *);
_CRTIMP    ϰ _wsearchenv(ֻ wchar_t *, ֻ wchar_t *, wchar_t *);
_CRTIMP    ϰ _wsplitpath(ֻ wchar_t *, wchar_t *, wchar_t *, wchar_t *, wchar_t *);

# _WSTDLIBP_DEFINED
#
#  /* ndef _MAC */

/* --------- The following functions are OBSOLETE --------- */
/* The Win32 API SetErrorMode, Beep and Sleep should be used instead. */
#δ _MAC
_CRTIMP  ϰ _seterrormode();
_CRTIMP  ϰ _beep(޷, ޷);
_CRTIMP  ϰ _sleep(޷ long);
#  /* ndef _MAC */
/* --------- The preceding functions are OBSOLETE --------- */

#  /* _POSIX_ */


#     !__STDC__
/* --------- The declarations below should not be in stdlib.h --------- */
/* --------- and will be removed in a future release. Include --------- */
/* --------- ctype.h to obtain these declarations.            --------- */
#δ tolower     /* tolower has been undefined - use function */
_CRTIMP  ϰ tolower();
#  /* tolower */
#δ toupper     /* toupper has been undefined - use function */
_CRTIMP  ϰ toupper();
#  /* toupper */
/* --------- The declarations above will be removed.          --------- */
#


#     !__STDC__

#δ _POSIX_

/* Non-ANSI names ѭ compatibility */

#δ __cplusplus
# max(a,b)    (((a) > (b)) ? (a) : (b))
# min(a,b)    (((a) < (b)) ? (a) : (b))
#

# sys_errlist _sys_errlist
# sys_nerr    _sys_nerr
# environ     _environ

_CRTIMP ַ * ϰ ecvt(˫, ,  *,  *);
_CRTIMP ַ * ϰ fcvt(˫, ,  *,  *);
_CRTIMP ַ * ϰ gcvt(˫, , ַ *);
_CRTIMP ַ * ϰ itoa(, ַ *, );
_CRTIMP ַ * ϰ ltoa(long, ַ *, );
        onexit_t ϰ onexit(onexit_t);
_CRTIMP     ϰ putenv(ֻ ַ *);
_CRTIMP    ϰ swab(ַ *, ַ *, );
_CRTIMP ַ * ϰ ultoa(޷ long, ַ *, );

#  /* _POSIX_ */

#  /* __STDC__ */

#Ѷ  __cplusplus
}

#

#Ѷ  _MSC_VER
#ָ pack(pop)
#  /* _MSC_VER */

#  /* _INC_STDLIB */
