/***
*sys/stat.h - defines structure used by stat() and fstat()
*
*       Copyright (c) 1985-1997, Microsoft Corporation. All rights reserved.
*
*Purpose:
*       This file defines the structure used by the _stat() and _fstat()
*       routines.
*       [System V]
*
*       [Public]
*
****/

# _MSC_VER > 1000
#ָ once
#

#δ _INC_STAT
# _INC_STAT

# !Ѷ(_WIN32) && !defined(_MAC)
# ERROR: Only Mac or Win32 targets supported!
#


#Ѷ  _MSC_VER
#ָ pack(push,8)
#  /* _MSC_VER */

#Ѷ __cplusplus
ⲿ "C" {
#



/* Define _CRTIMP */

#δ _CRTIMP
#Ѷ  _DLL
# _CRTIMP __declspec(dllimport)
#   /* ndef _DLL */
# _CRTIMP
#  /* _DLL */
#  /* _CRTIMP */


/* Define ϰ ѭ non-Microsoft compilers */

#     ( !Ѷ(_MSC_VER) && !defined(ϰ) )
# ϰ
#

/* Define _CRTAPI1 (ѭ compatibility with the NT SDK) */

#δ _CRTAPI1
#	_MSC_VER >= 800 && _M_IX86 >= 300
# _CRTAPI1 ϰ
#
# _CRTAPI1
#
#


# <sys/types.h>


#δ _TIME_T_DEFINED
Ͷ long time_t;
# _TIME_T_DEFINED
#


#Ѷ _WIN32
#δ _WCHAR_T_DEFINED
Ͷ ޷  wchar_t;
# _WCHAR_T_DEFINED
#
# /* _WIN32 */


/* define structure ѭ returning status information */

#δ _STAT_DEFINED

ṹ _stat_ {
        _dev_t st_dev;
        _ino_t st_ino;
        ޷  st_mode;
         st_nlink;
         st_uid;
         st_gid;
        _dev_t st_rdev;
        _off_t st_size;
        time_t st_atime;
        time_t st_mtime;
        time_t st_ctime;
        };

#     !__STDC__

/* Non-ANSI names ѭ compatibility */

ṹ stat_ {
        _dev_t st_dev;
        _ino_t st_ino;
        ޷  st_mode;
         st_nlink;
         st_uid;
         st_gid;
        _dev_t st_rdev;
        _off_t st_size;
        time_t st_atime;
        time_t st_mtime;
        time_t st_ctime;
        };

#  /* __STDC__ */

#     _INTEGRAL_MAX_BITS >= 64
ṹ _stat_i64 {
        _dev_t st_dev;
        _ino_t st_ino;
        ޷  st_mode;
         st_nlink;
         st_uid;
         st_gid;
        _dev_t st_rdev;
         st_size;
        time_t st_atime;
        time_t st_mtime;
        time_t st_ctime;
        };
#

# _STAT_DEFINED
#


# _S_IFMT         0170000         /* file type mask */
# _S_IFDIR        0040000         /* directory */
# _S_IFCHR        0020000         /* character special */
# _S_IFIFO        0010000         /* pipe */
# _S_IFREG        0100000         /* regular */
# _S_IREAD        0000400         /* read permission, owner */
# _S_IWRITE       0000200         /* write permission, owner */
# _S_IEXEC        0000100         /* execute/search permission, owner */


/* Function prototypes */

_CRTIMP  ϰ _fstat(, ṹ _stat_ *);
_CRTIMP  ϰ _stat(ֻ ַ *, ṹ _stat_ *);

#     _INTEGRAL_MAX_BITS >= 64
_CRTIMP  ϰ _fstati64(, ṹ _stat_i64 *);
_CRTIMP  ϰ _stati64(ֻ ַ *, ṹ _stat_i64 *);
#

#Ѷ _WIN32
#δ _WSTAT_DEFINED

/* wide function prototypes, also declared in wchar.h  */

_CRTIMP  ϰ _wstat(ֻ wchar_t *, ṹ _stat_ *);

#     _INTEGRAL_MAX_BITS >= 64
_CRTIMP  ϰ _wstati64(ֻ wchar_t *, ṹ _stat_i64 *);
#

# _WSTAT_DEFINED
#
# /* _WIN32 */


#     !__STDC__

/* Non-ANSI names ѭ compatibility */

# S_IFMT   _S_IFMT
# S_IFDIR  _S_IFDIR
# S_IFCHR  _S_IFCHR
# S_IFREG  _S_IFREG
# S_IREAD  _S_IREAD
# S_IWRITE _S_IWRITE
# S_IEXEC  _S_IEXEC

_CRTIMP  ϰ fstat(, ṹ stat_ *);
_CRTIMP  ϰ stat(ֻ ַ *, ṹ stat_ *);

#  /* __STDC__ */


#Ѷ __cplusplus
}
#

#Ѷ  _MSC_VER
#ָ pack(pop)
#  /* _MSC_VER */

#  /* _INC_STAT */
