/***
*time.h - definitions/declarations ѭ time routines
*
*       Copyright (c) 1985-1997, Microsoft Corporation. All rights reserved.
*
*Purpose:
*       This file has declarations of time routines and defines
*       the structure returned by the localtime and gmtime routines and
*       used by asctime.
*       [ANSI/System V]
*
*       [Public]
*
****/

#     _MSC_VER > 1000
#ָ once
#

#δ _INC_TIME
# _INC_TIME

#     !Ѷ(_WIN32) && !defined(_MAC)
# ERROR: Only Mac or Win32 targets supported!
#


#Ѷ  _MSC_VER
/*
 * Currently, all MS C compilers ѭ Win32 platforms ֵ to 8 byte
 * alignment.
 */
#ָ pack(push,8)
#  /* _MSC_VER */

#Ѷ  __cplusplus
ⲿ "C" {
#



/* Define _CRTIMP */

#δ _CRTIMP
#Ѷ  _DLL
# _CRTIMP __declspec(dllimport)
#   /* ndef _DLL */
# _CRTIMP
#  /* _DLL */
#  /* _CRTIMP */


/* Define ϰ ѭ non-Microsoft compilers */

#     ( !Ѷ(_MSC_VER) && !defined(ϰ) )
# ϰ
#

/* Define _CRTAPI1 (ѭ compatibility with the NT SDK) */

#δ _CRTAPI1
#	_MSC_VER >= 800 && _M_IX86 >= 300
# _CRTAPI1 ϰ
#
# _CRTAPI1
#
#

#δ _MAC
#δ _WCHAR_T_DEFINED
Ͷ ޷  wchar_t;
# _WCHAR_T_DEFINED
#
#  /* ndef _MAC */

/* Define the implementation defined time type */

#δ _TIME_T_DEFINED
Ͷ long time_t;        /* time value */
# _TIME_T_DEFINED     /* avoid multiple def's of time_t */
#

#δ _CLOCK_T_DEFINED
Ͷ long clock_t;
# _CLOCK_T_DEFINED
#

#δ _SIZE_T_DEFINED
Ͷ ޷  size_t;
# _SIZE_T_DEFINED
#


/* Define NULL pointer value */

#δ NULL
#Ѷ __cplusplus
# NULL    0
#
# NULL    (( *)0)
#
#


#δ _TM_DEFINED
ṹ tm {
         tm_sec;     /* seconds after the minute - [0,59] */
         tm_min;     /* minutes after the hour - [0,59] */
         tm_hour;    /* hours since midnight - [0,23] */
         tm_mday;    /* day of the month - [1,31] */
         tm_mon;     /* months since January - [0,11] */
         tm_year;    /* years since 1900 */
         tm_wday;    /* days since Sunday - [0,6] */
         tm_yday;    /* days since January 1 - [0,365] */
         tm_isdst;   /* daylight savings time flag */
        };
# _TM_DEFINED
#


/* Clock ticks macro - ANSI version */

# CLOCKS_PER_SEC  1000


/* Extern declarations ѭ the global variables used by the ctime family of
 * routines.
 */

/* non-zero  daylight savings time is used */
_CRTIMP ⲿ  _daylight;

/* offset ѭ Daylight Saving Time */
_CRTIMP ⲿ long _dstbias;

/* difference in seconds between GMT and local time */
_CRTIMP ⲿ long _timezone;

/* standard/daylight savings time zone names */
_CRTIMP ⲿ ַ * _tzname[2];


/* Function prototypes */

_CRTIMP ַ * ϰ asctime(ֻ ṹ tm *);
_CRTIMP ַ * ϰ ctime(ֻ time_t *);
_CRTIMP clock_t ϰ clock();
_CRTIMP ˫ ϰ difftime(time_t, time_t);
_CRTIMP ṹ tm * ϰ gmtime(ֻ time_t *);
_CRTIMP ṹ tm * ϰ localtime(ֻ time_t *);
_CRTIMP time_t ϰ mktime(ṹ tm *);
_CRTIMP size_t ϰ strftime(ַ *, size_t, ֻ ַ *,
        ֻ ṹ tm *);
_CRTIMP ַ * ϰ _strdate(ַ *);
_CRTIMP ַ * ϰ _strtime(ַ *);
_CRTIMP time_t ϰ time(time_t *);

#Ѷ  _POSIX_
_CRTIMP  ϰ tzset();
#
_CRTIMP  ϰ _tzset();
#

/* --------- The following functions are OBSOLETE --------- */
/* The Win32 API GetLocalTime and SetLocalTime should be used instead. */
޷ ϰ _getsystime(ṹ tm *);
޷ ϰ _setsystime(ṹ tm *, ޷);
/* --------- The preceding functions are OBSOLETE --------- */


#δ _SIZE_T_DEFINED
Ͷ ޷  size_t;
# _SIZE_T_DEFINED
#

#δ _MAC
#δ _WTIME_DEFINED

/* wide function prototypes, also declared in wchar.h */
 
_CRTIMP wchar_t * ϰ _wasctime(ֻ ṹ tm *);
_CRTIMP wchar_t * ϰ _wctime(ֻ time_t *);
_CRTIMP size_t ϰ wcsftime(wchar_t *, size_t, ֻ wchar_t *,
        ֻ ṹ tm *);
_CRTIMP wchar_t * ϰ _wstrdate(wchar_t *);
_CRTIMP wchar_t * ϰ _wstrtime(wchar_t *);

# _WTIME_DEFINED
#
#  /* ndef _MAC */


#     !__STDC__ || Ѷ(_POSIX_)

/* Non-ANSI names ѭ compatibility */

# CLK_TCK  CLOCKS_PER_SEC

_CRTIMP ⲿ  daylight;
_CRTIMP ⲿ long timezone;
_CRTIMP ⲿ ַ * tzname[2];

_CRTIMP  ϰ tzset();

#  /* __STDC__ */


#Ѷ  __cplusplus
}
#

#Ѷ  _MSC_VER
#ָ pack(pop)
#  /* _MSC_VER */

#  /* _INC_TIME */
