/***
*wctype.h - declarations ѭ wide character functions
*
*       Copyright (c) 1992-1997, Microsoft Corporation. All rights reserved.
*       Created from wchar.h January 1996 by P.J. Plauger
*
*Purpose:
*       This file contains the types, macros and function declarations ѭ
*       all ctype-style wide-character functions.  They may also be declared in
*       wchar.h.
*       [ISO]
*
*       Note: keep in sync with ctype.h and wchar.h.
*
*       [Public]
*
****/

#δ _MAC

#δ _INC_WCTYPE
# _INC_WCTYPE

#     !Ѷ(_WIN32) && !defined(_MAC)
# ERROR: Only Mac or Win32 targets supported!
#


#Ѷ  _MSC_VER
#ָ pack(push,8)
#  /* _MSC_VER */

#Ѷ  __cplusplus
ⲿ "C" {
#


/* Define _CRTIMP */

#δ _CRTIMP
#Ѷ  _DLL
# _CRTIMP __declspec(dllimport)
#   /* ndef _DLL */
# _CRTIMP
#  /* _DLL */
#  /* _CRTIMP */

/* Define _CRTIMP */
#δ _CRTIMP
#Ѷ  _DLL
# _CRTIMP __declspec(dllimport)
#   /* ndef _DLL */
# _CRTIMP
#  /* _DLL */
#  /* _CRTIMP */

/* Define ϰ ѭ non-Microsoft compilers */

#     ( !Ѷ(_MSC_VER) && !defined(ϰ) )
# ϰ
#

/* Define _CRTAPI1 (ѭ compatibility with the NT SDK) */

#δ _CRTAPI1
#	_MSC_VER >= 800 && _M_IX86 >= 300
# _CRTAPI1 ϰ
#
# _CRTAPI1
#
#


#δ _WCHAR_T_DEFINED
Ͷ ޷  wchar_t;
# _WCHAR_T_DEFINED
#

#δ _WCTYPE_T_DEFINED
Ͷ wchar_t wint_t;
Ͷ wchar_t wctype_t;
# _WCTYPE_T_DEFINED
#


#δ WEOF
# WEOF (wint_t)(0xFFFF)
#

/*
 * This declaration allows the user access to the ctype look-up
 * array _ctype defined in ctype.obj by simply including ctype.h
 */

_CRTIMP ⲿ ޷  _ctype[];

#     Ѷ(_DLL) && defined(_M_IX86)
/* Retained ѭ compatibility with VC++ 5.0 and earlier versions */
_CRTIMP ޷  ** ϰ __p__pctype();
_CRTIMP wctype_t ** ϰ ___p__pwctype();
#
_CRTIMP ⲿ ޷  *_pctype;
_CRTIMP ⲿ wctype_t *_pwctype;


/* set bit masks ѭ the possible character types */

# _UPPER          0x1     /* upper  letter */
# _LOWER          0x2     /* lower  letter */
# _DIGIT          0x4     /* digit[0-9] */
# _SPACE          0x8     /* tab, carriage , newline, */
                                /* vertical tab or form feed */
# _PUNCT          0x10    /* punctuation character */
# _CONTROL        0x20    /* control character */
# _BLANK          0x40    /* space ַ */
# _HEX            0x80    /* hexadecimal digit */

# _LEADBYTE       0x8000                  /* multibyte leadbyte */
# _ALPHA          (0x0100|_UPPER|_LOWER)  /* alphabetic character */


/* Function prototypes */

#δ _WCTYPE_DEFINED

/* Character classification function prototypes */
/* also declared in ctype.h */

_CRTIMP  ϰ iswalpha(wint_t);
_CRTIMP  ϰ iswupper(wint_t);
_CRTIMP  ϰ iswlower(wint_t);
_CRTIMP  ϰ iswdigit(wint_t);
_CRTIMP  ϰ iswxdigit(wint_t);
_CRTIMP  ϰ iswspace(wint_t);
_CRTIMP  ϰ iswpunct(wint_t);
_CRTIMP  ϰ iswalnum(wint_t);
_CRTIMP  ϰ iswprint(wint_t);
_CRTIMP  ϰ iswgraph(wint_t);
_CRTIMP  ϰ iswcntrl(wint_t);
_CRTIMP  ϰ iswascii(wint_t);
_CRTIMP  ϰ isleadbyte();

_CRTIMP wchar_t ϰ towupper(wchar_t);
_CRTIMP wchar_t ϰ towlower(wchar_t);

_CRTIMP  ϰ iswctype(wint_t, wctype_t);

/* --------- The following functions are OBSOLETE --------- */
_CRTIMP  ϰ is_wctype(wint_t, wctype_t);
/*  --------- The preceding functions are OBSOLETE --------- */

# _WCTYPE_DEFINED
#

#δ _WCTYPE_INLINE_DEFINED
#δ __cplusplus
# iswalpha(_c)    ( iswctype(_c,_ALPHA) )
# iswupper(_c)    ( iswctype(_c,_UPPER) )
# iswlower(_c)    ( iswctype(_c,_LOWER) )
# iswdigit(_c)    ( iswctype(_c,_DIGIT) )
# iswxdigit(_c)   ( iswctype(_c,_HEX) )
# iswspace(_c)    ( iswctype(_c,_SPACE) )
# iswpunct(_c)    ( iswctype(_c,_PUNCT) )
# iswalnum(_c)    ( iswctype(_c,_ALPHA|_DIGIT) )
# iswprint(_c)    ( iswctype(_c,_BLANK|_PUNCT|_ALPHA|_DIGIT) )
# iswgraph(_c)    ( iswctype(_c,_PUNCT|_ALPHA|_DIGIT) )
# iswcntrl(_c)    ( iswctype(_c,_CONTROL) )
# iswascii(_c)    ( (޷)(_c) < 0x80 )

# isleadbyte(_c)  (_pctype[(޷ ַ)(_c)] & _LEADBYTE)
#   /* __cplusplus */
  ϰ iswalpha(wint_t _C) { (iswctype(_C,_ALPHA)); }
  ϰ iswupper(wint_t _C) { (iswctype(_C,_UPPER)); }
  ϰ iswlower(wint_t _C) { (iswctype(_C,_LOWER)); }
  ϰ iswdigit(wint_t _C) { (iswctype(_C,_DIGIT)); }
  ϰ iswxdigit(wint_t _C) { (iswctype(_C,_HEX)); }
  ϰ iswspace(wint_t _C) { (iswctype(_C,_SPACE)); }
  ϰ iswpunct(wint_t _C) { (iswctype(_C,_PUNCT)); }
  ϰ iswalnum(wint_t _C) { (iswctype(_C,_ALPHA|_DIGIT)); }
  ϰ iswprint(wint_t _C)
        { (iswctype(_C,_BLANK|_PUNCT|_ALPHA|_DIGIT)); }
  ϰ iswgraph(wint_t _C)
        { (iswctype(_C,_PUNCT|_ALPHA|_DIGIT)); }
  ϰ iswcntrl(wint_t _C) { (iswctype(_C,_CONTROL)); }
  ϰ iswascii(wint_t _C) { ((޷)(_C) < 0x80); }

  ϰ isleadbyte( _C)
        { (_pctype[(޷ ַ)(_C)] & _LEADBYTE); }
#  /* __cplusplus */
# _WCTYPE_INLINE_DEFINED
#  /* _WCTYPE_INLINE_DEFINED */

Ͷ wchar_t wctrans_t;
_CRTIMP wint_t ϰ towctrans(wint_t, wctrans_t);
_CRTIMP wctrans_t ϰ wctrans(ֻ ַ *);
_CRTIMP wctype_t ϰ wctype(ֻ ַ *);


#Ѷ  __cplusplus
}
#

#Ѷ  _MSC_VER
#ָ pack(pop)
#  /* _MSC_VER */

#  /* _INC_WCTYPE */

#  /* ndef _MAC */

